













#include "../ext/struct.h"







void do_compare_pdb( void );

void do_my_compare_pdb( char dir[], char *ext[], char out_fname[], 
  int fname_buffer );

void do_compare_pdb_single_file_pair( char dir[], char *ext_a, char *ext_b,
  FILE *out );

void get_best_free_energy_pdb_file_name( char fname[], char dir[], char *ext );

int get_best_free_energy_pdb_single_file( char dir[], char *ext, int i, int best,
  STAT *g_best );

int get_best_free_energy_pdb_single_fh( FILE *in, int best, STAT *g_best, int i );

void do_compare_pdb_single_file_name_pair( char fname_a[], char fname_b[], 
  char *ext_a, char *ext_b, FILE *out );

void do_compare_pdb_single_molecule_pair( MOL_LIST *a, MOL_LIST *b,
  char fname_a[], char fname_b[], char *ext_a, char *ext_b, FILE *out );

void do_compare_pdb_single_mol_pair_w_cells( MOL_LIST *a, MOL_LIST *b,
  XYZ_CELL *major_cell, XYZ_CELL *minor_cell, char fname_a[], char fname_b[],
  char *ext_a, char *ext_b, FILE *out );

void get_and_print_compare_pdb_mol_lister( MOL_LIST *a, MOL_LIST *b, FILE *out );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void do_compare_regions( void );

void do_compare_regions_w_fh( FILE *out );

void do_compare_regions_single_sub( char a[], char b[], FILE *out );

void do_compare_regions_single_sub_pair( char sub_a[], char sub_b[], char fname_a[],
  char fname_b[], FILE *out );

void do_compare_regions_single_mol_pair( MOL_LIST *a, MOL_LIST *b, char sub_a[],
  char sub_b[], FILE *out );

int get_numb_resid_peptide( MOL_LIST *a );

void do_compare_regions_single_mol_reg( MOL_LIST *a, MOL_LIST *b, char sub_a[], 
  char sub_b[], int start, int end, FILE *out );

void do_compare_regions_single_mol_reg_w_cells( MOL_LIST *a, MOL_LIST *b,
  XYZ_CELL *major_cell, XYZ_CELL *minor_cell, char sub_a[], char sub_b[],
  int start, int end, FILE *out );


















