#include "evol.h"


























void do_evol( void )
{

  extern char minor_mode;
  
  switch ( minor_mode ) {
  
  case 'v' :
    /*  In change.c:  */
    do_evol_change();
    break;
    
  case 'c' :
    /*  In comp.c:  */
    do_mol_compare();
    break;
    
  case 'n' :
    /*  In comp.c:  */
    do_zinc_finger_compare();
    break;
    
  case 'r' :
    /*  In ft.c:  */
    do_pdb_file_rotate();
    break;
    
  case 'R' :
    /*  In ft.c:  */
    do_pdb_mol_file_rotate();
    break;
    
  case 'b' :
    /*  In bin_change.c:  */
    do_evol_change_bin();
    break;
    
  case 'B' :
    /*  In bin_change.c:  */
    do_mol_compare_bin();
    break;
    
  case 'x' :
    /*  In replace.c:  */
    do_replace();
    break;
    
  case 'X' :
    /*  In cp.c:  */
    do_compare_pdb();
    break;
    
  case 'd' :
    /*  In cp.c:  */
    do_compare_regions();
    break;
    
  case 'D' :
    /*  In rmsd.c:  */
    do_rotated_mol_dists();
    break;
    
  case 'e' :
    /*  In bend.c:  */
    do_bend();
    break;
        
  default :
    error( 4000, "Minor mode unrecognized by evol pass.\n" );
    break;
  
  }

}
































