
















#include "../ext/struct.h"










void rotate_mol_single_iter_newton( MX_STRUCT *my_mx, XYZ_CELL *major_cell, 
  XYZ_CELL *minor_cell );
  
void get_step_matrix_newton( MX_STRUCT *my_mx, XYZ_CELL *major_cell, 
  XYZ_CELL *minor_cell );

void update_vectors_newton( MX_STRUCT *my_mx );

void update_param_vectors_newton( MATRIX *p, MATRIX *d );

void rotate_mol_final_single_iter_newton( MX_STRUCT *my_mx, 
  XYZ_CELL *major_cell, XYZ_CELL *minor_cell );

void get_step_matrix_final_newton( MX_STRUCT *my_mx, XYZ_CELL *major_cell,
  XYZ_CELL *minor_cell );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



void set_f_matrix_newton( MX_STRUCT *my_mx, XYZ_CELL *major_cell,
  XYZ_CELL *minor_cell );

void set_f_matrix_newton_single_elem( STAT *fptr, int j, MATRIX *p,
  XYZ_CELL *major_cell, XYZ_CELL *minor_cell );

STAT get_single_deriv_rotation( MATRIX *p, XYZ *major_pt, XYZ *minor_pt, int j );

STAT get_single_deriv_rotation_xyz_cells( MATRIX *p, XYZ_CELL *major_cell,
  XYZ_CELL *minor_cell, int j );

void set_f_matrix_final_newton( MX_STRUCT *my_mx, XYZ_CELL *major_cell, 
  XYZ_CELL *minor_cell );

void set_f_matrix_final_newton_single_elem( STAT *fptr, int j, MATRIX *p,
  XYZ_CELL *major_cell, XYZ_CELL *minor_cell );

STAT get_single_deriv_euclidean_rotation( MATRIX *p, XYZ *major_pt, XYZ *minor_pt, 
  int j );

STAT get_single_deriv_euclidean_rotation_xyz_cells( MATRIX *p, XYZ_CELL *major_cell,
  XYZ_CELL *minor_cell, int j );

void set_j_matrix_newton( MX_STRUCT *my_mx, XYZ_CELL *major_cell, 
  XYZ_CELL *minor_cell );

STAT get_j_matrix_newton_single_elem( MATRIX *p, XYZ_CELL *major_cell,
  XYZ_CELL *minor_cell, int a, int b );

void set_j_matrix_final_newton( MX_STRUCT *my_mx, XYZ_CELL *major_cell, 
  XYZ_CELL *minor_cell );

STAT get_j_matrix_final_newton_single_elem( MATRIX *p, XYZ_CELL *major_cell,
  XYZ_CELL *minor_cell, int a, int b );

STAT get_double_deriv_notation( MATRIX *p, XYZ *major_pt, XYZ *minor_pt,
  int a, int b );
  
STAT get_rotation_deriv( XYZ *pt, MATRIX *p, char index, int j );

STAT get_rotation_deriv_x( XYZ *pt, MATRIX *p, char index );

STAT get_rotation_deriv_y( XYZ *pt, MATRIX *p, char index );

STAT get_rotation_deriv_z( XYZ *pt, MATRIX *p, char index );

















  
  
  