












#include "../ext/struct.h"












typedef struct fh_struct {
  FILE *ft_fh;
  FILE *ind_fh;
  FILE *align_fh;
  FILE *label_fh;
} FH;











void do_ft_column_count( void );

void do_my_ft_column_count( void );

void do_ft_column_count_w_spec_list( STR_LIST *spec_header );

void do_ft_column_count_single_spec_and_step( STR_LIST **spec );

void do_ft_column_count_single_spec( STR_LIST *spec );

void do_my_ft_column_count_single_spec( char fname_base[], char out_fname[] );

void do_ft_column_count_single_spec_w_fh( char fname_base[], FILE *out );

void do_ft_column_count_single_spec_gene_list( GENE_LIST *gene_header,
  char fname_base[], MOTIF *mf, FILE *out );

void do_my_ft_column_count_single_spec_gene_list( GENE_LIST *gene_header,
  char fname_base[], MOTIF *mf, FH *my_fh, FILE *out );

void do_ft_column_count_single_spec_gene_list_w_fhs( GENE_LIST *gene_header,
  MOTIF *mf, FH *my_fh, FILE *out );

void do_ft_column_count_single_gene( GENE_LIST *gene_header, 
  GENE_LABEL *my_gene, MOTIF *mf, SEQ seq_numb, FH *my_fh, FILE *out );

void do_ft_column_count_single_existing_gene( GENE_LIST *gene_header,
  GENE_LABEL *my_gene, MOTIF *mf, SEQ seq_numb, FH *my_fh, FILE *out );

void put_matching_ft_column_count_gene_column_fh( GENE_LIST *gene, MOTIF *mf,
  FH *my_fh, FILE *out );

void initialize_nucl_count_array( int nucl[] );

void put_my_matching_ft_column_count_gene_column_fh( GENE_LIST *gene, int nucl[], 
  WIND *my_wind, MOTIF *mf, FH *my_fh, FILE *out );

void get_ft_column_count_gene_nucl_array( int nucl[], GENE_LIST *gene,
  WIND *my_wind, char site );

void get_ft_column_count_gene_nucl_array_single_occur_and_step( int nucl[],
  WIND *my_wind, OCR_LIST **occur, char site );

void get_ft_column_count_gene_nucl_array_single_occur( int nucl[], WIND *my_wind,
  OCR_LIST *occur, char site );

void get_ft_column_count_gene_nucl_array_inside_wind( int nucl[], OCR_LIST *occur, 
  char site );

void put_matching_ft_column_count_gene_nucl_array( int nucl[], FILE *out );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void do_ft_column_count_combine( void );

void do_my_ft_column_count_combine( void );

void do_ft_column_count_combine_w_spec_list( STR_LIST *spec_header );

INDEX get_numb_of_spec_str_list( STR_LIST *spec_header );

void do_ft_column_count_combine_w_fpos_cell( STR_LIST *spec_header, 
  FPOS_CELL *fpos_cell );

void do_ft_column_count_combine_w_fh( STR_LIST *spec_header, FPOS_CELL *fpos_cell,
  FILE *gene_fh, FILE *out );

void print_ft_column_count_combine_header( STR_LIST *spec_header, FILE *out );

void do_my_ft_column_count_combine_w_fh( STR_LIST *spec_header, 
  FPOS_CELL *fpos_cell, FILE *gene_fh, FILE *out );

int ft_column_count_combine_still_going( STR_LIST *spec_header, 
  FPOS_CELL *fpos_cell );

void do_ft_column_count_combine_single_seq( STR_LIST *spec_header, 
  FPOS_CELL *fpos_cell, SEQ seq_numb, FILE *gene_fh, FILE *out );

void do_ft_column_count_combine_single_spec_and_step( STR_LIST **spec,
  FPOS_CELL *fpos_cell, SEQ seq_numb, INDEX numb, FILE *gene_fh, FILE *out );

void do_ft_column_count_combine_single_spec( STR_LIST *spec, FPOS_CELL *fpos_cell,
  SEQ seq_numb, INDEX numb, FILE *gene_fh, FILE *out );

void do_my_ft_column_count_combine_single_spec( FPOS_CELL *fpos_cell, SEQ seq_numb,
  INDEX numb, FILE *gene_fh, FILE *in, FILE *out );

void do_ft_column_count_combine_single_spec_line( char line[], SEQ seq_numb,
  INDEX numb, FILE *gene_fh, FILE *out );

void do_ft_column_count_combine_beginning_entries( char line[], SEQ seq_numb,
  FILE *gene_fh, FILE *out );

void get_gene_from_gene_info_fh_acc( char gene[], char acc[], FILE *fh );

void do_my_ft_column_count_combine_single_spec_line( char line[], FILE *out );
  
  

/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void get_ft_column_count_single_fname_base( char fname[], char spec[] );

void get_ft_column_count_single_spec_out_fname( char fname[], char spec[] );





















