




















#include "struct.h"










GENE_SLIST *get_gene_slist_struct_from_fname( GENE_SLIST *my_list, 
  char fname_base[] );

GENE_SLIST *get_my_gene_slist_struct_from_fname( GENE_SLIST *my_list, 
  char fname_base[] );

GENE_SLIST *get_gene_slist_struct_first_slists( GENE_SLIST *my_list,
  char fname_base[] );

SLIST *gene_slist_fname( SLIST *x, char fname_base[], char ext[] );

SLIST *gene_slist_w_fh( SLIST *gene_header, FILE *in );

SLIST *get_slist_single_line( SLIST *gene_header, char line[] );

GENE_SLIST *get_gene_slist_struct_multi_files( GENE_SLIST *my_list, 
  char fname_base[] );

GENE_SLIST *get_gene_slist_struct_multi_single_files( GENE_SLIST *my_list,
  char fname_base[] );

GENE_SLIST *get_gene_slist_struct_multi_many_files( GENE_SLIST *my_list, 
  char fname_base[] );

GENE_SLIST *get_my_gene_slist_struct_multi_single_files( GENE_SLIST *my_list,
  char fname_base[] );

GENE_SLIST *get_gene_slist_intersection_files( GENE_SLIST *my_list, 
  char fname_base[] );

GENE_SLIST *get_gene_slist_single_intersection_files( GENE_SLIST *my_list,
  char fname_base[] );

GENE_SLIST *get_gene_slist_intersection_and_compl_files( GENE_SLIST *my_list,
  char fname_base[] );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



SLIST *get_gene_slist_compl_two_files( SLIST *gene_header, char fname_base[],
  char ext_yes[], char ext_no[] );

SLIST *get_gene_slist_compl_two_files_fhs( SLIST *gene_header, FILE *yes_fh,
  FILE *no_fh );

SLIST *get_gene_slist_single_yes_line( SLIST *gene_header, char yes_line[],
  char no_line[], FILE *no_fh );

int scan_to_matching_gene_numb_line( char no_line[], int yes_numb, FILE *no_fh );

SLIST *set_and_put_gene_slister_line_end_of_list( SLIST *gene_header, 
  char yes_line[] );

SLIST *gene_slist_compl_1_and_2_files( SLIST *gene_header, char fname_base[],
  char ext_yes[], char ext_no1[], char ext_no2[] );

SLIST *gene_slist_compl_1_and_2_w_fhs( SLIST *gene_header, FILE *yes_fh, 
  FILE *no_1_fh, FILE *no_2_fh );

SLIST *gene_slist_compl_1_and_2_single_line( SLIST *gene_header, char yes_line[],
  char no_1_line[], char no_2_line[], FILE *no_1_fh, FILE *no_2_fh );

SLIST *gene_slist_intersection_slist( SLIST *gene_header, char fname_base[],
  char ext1[], char ext2[] );

SLIST *get_slist_intersection_w_fhs( SLIST *gene_header, FILE *a_fh, FILE *b_fh );

SLIST *get_slist_intersection_single_line( SLIST *gene_header, char a_line[], 
  char b_line[], FILE *b_fh );

SLIST *gene_intersection_slist_w_compl( SLIST *gene_header, char fname_base[],
  char ext_yes_a[], char ext_yes_b[], char ext_no_a[], char ext_no_b[] );

SLIST *gene_intersection_slist_w_compl_fhs( SLIST *gene_header, FILE *yes_a_fh,
  FILE *yes_b_fh, FILE *no_a_fh, FILE *no_b_fh );

SLIST *gene_intersection_slist_compl_single_line( SLIST *gene_header,
  char yes_a_line[], char yes_b_line[], char no_a_line[], char no_b_line[],
  FILE *yes_b_fh, FILE *no_a_fh, FILE *no_b_fh );

SLIST *gene_fourway_intersection( SLIST *gene_header, char fname_base[],
  char ext_a[], char ext_b[], char ext_c[], char ext_d[] );

SLIST *get_fourway_intersection_w_fh( SLIST *gene_header, FILE *a_fh, FILE *b_fh,
  FILE *c_fh, FILE *d_fh );

SLIST *get_fourway_intersection_single_line( SLIST *gene_header, char a_line[],
  char b_line[], char c_line[], char d_line[], FILE *b_fh, FILE *c_fh, FILE *d_fh );




/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



GENE_SLIST *create_gene_slist( GENE_SLIST *xx );

GENE_SLIST *initialize_gene_slist( GENE_SLIST *xx );

void initialize_gene_slist_labels( GENE_SLIST *xx );


















