
















#include "struct.h"













void do_go_enrichment_counts( void );

GENE_SLIST *get_gene_slist_for_go_enrichment( GENE_SLIST *my_list, 
  char gene_list_base[], char spec_one[], char spec_two[], char input_fname[], 
  char my_nucl );

void do_go_enrichment_counts_gene_lists( GENE_SLIST *anc_list, 
  GENE_SLIST *node_list, char go_gene_fname[], char output_fname[] );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void do_go_enrichment_counts_w_term_list( GENE_SLIST *anc_list, 
  GENE_SLIST *node_list, SLIST *term_header, char go_gene_fname[],
  char output_fname[] );

GO_CAT_LIST *get_go_enrichment_counts( GO_CAT_LIST *go_header, GENE_SLIST *my_list,
  SLIST *term_header, char go_gene_fname[] );

GO_CAT_LIST *get_go_enrichment_counts_fh( GO_CAT_LIST *go_header, 
  GENE_SLIST *my_list, SLIST *term_header, FILE *in );

GO_CAT_LIST *get_and_put_go_cat_lister_counts( GO_CAT_LIST *go_header,
  GENE_SLIST *my_list, SLIST *term_header, FILE *in );

GO_CAT_LIST *get_and_put_my_go_cat_lister_counts( GO_CAT_LIST *go_header,
  GENE_SLIST *my_list, char label[], FILE *in );

GO_CAT_LIST *get_and_put_new_go_cat_lister_counts( GO_CAT_LIST *go_header,
  GENE_SLIST *my_list, SLIST *go_gene_header, char label[], FILE *in );

GO_CAT_LIST *get_and_put_my_new_go_cat_lister_counts( GO_CAT_LIST *go_header,
  SLIST *target_header, SLIST *go_gene_header, SLIST *total_header, char label[] );

GO_CAT_LIST *get_and_put_significant_go_cat_lister_counts( GO_CAT_LIST *go_header,
  char label[], int x_genes, int target_genes, int go_genes, int total_genes,
  PVAL pval );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void print_go_enrichment_counts_output_fname( GO_CAT_LIST *go_header, 
  GENE_SLIST *anc_list, GENE_SLIST *node_list, char go_gene_fname[],
  char output_fname[] );

void print_go_enrichment_counts_summary( GO_CAT_LIST *go_header, 
  GENE_SLIST *anc_list, GENE_SLIST *node_list, char go_gene_fname[],
  char output_fname[] );

void print_go_enrichment_counts_summary_fh( GO_CAT_LIST *go_header,
  GENE_SLIST *anc_list, GENE_SLIST *node_list, FILE *in, FILE *out );

void print_go_enrichment_counts_single_go_and_step( GO_CAT_LIST **go,
  GENE_SLIST *anc_list, GENE_SLIST *node_list, FILE *in, FILE *out );

void print_go_enrichment_counts_single_go( GO_CAT_LIST *go, GENE_SLIST *anc_list,
  GENE_SLIST *node_list, FILE *in, FILE *out );

void print_my_go_enrichment_counts_single_go( GO_CAT_LIST *go, 
  GENE_SLIST *anc_list, GENE_SLIST *node_list, SLIST *go_gene_header, FILE *out );

void print_go_enrichment_counts_header_entry( GO_CAT_LIST *go, FILE *out );

void print_go_enrichment_counts_single_go_sep( GO_CAT_LIST *go, 
  GENE_SLIST *anc_list, GENE_SLIST *node_list, SLIST *go_gene_header, FILE *out );

void print_go_enrichment_counts_sep_total_slist( GO_CAT_LIST *go,
  GENE_SLIST *anc_list, GENE_SLIST *node_list, SLIST *go_gene_header,
  SLIST *total_header, char notes[], FILE *out );

void print_go_enrichment_counts_full( GO_CAT_LIST *go_header, 
  GENE_SLIST *anc_list, GENE_SLIST *node_list, char go_gene_fname[], 
  char output_fname[] );

void print_go_enrichment_counts_full_fh( GO_CAT_LIST *go_header, 
  GENE_SLIST *anc_list, GENE_SLIST *node_list, FILE *in, FILE *out );

void print_go_enrichment_counts_full_single_go_and_step( GO_CAT_LIST **go,
  GENE_SLIST *anc_list, GENE_SLIST *node_list, FILE *in, FILE *out );

void print_go_enrichment_counts_full_single_go( GO_CAT_LIST *go,
  GENE_SLIST *anc_list, GENE_SLIST *node_list, FILE *in, FILE *out );

void print_my_go_enrichment_counts_full_single_go( GO_CAT_LIST *go,
  GENE_SLIST *anc_list, GENE_SLIST *node_list, SLIST *go_gene_header, FILE *out );

void print_go_enrichment_counts_full_body( GO_CAT_LIST *go, GENE_SLIST *anc_list,
  GENE_SLIST *node_list, SLIST *go_gene_header, FILE *out );

void print_go_enrichment_counts_full_body_single_node( GO_CAT_LIST *go,
  GENE_SLIST *my_list, SLIST *go_gene_header, char notes[], FILE *out );
  
  

/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



PVAL get_fishers_exact_test_pval( int nn, int n, int gg, int g );

























