

















#include "../ext/struct.h"









void set_matrix_inv( TT_MX *inv, TT_MX *mx );

void set_my_matrix_inv( TT_MX *inv, TT_MX *mx );

void calc_matrix_inv( TT_MX *inv, TT_MX *mx, TT_MX *vector, TT_MX *sol );

void compute_inv_column( TT_MX *inv, TT_MX *mx, TT_MX *vector, TT_MX *sol,
  INDEX col );

void get_ident_vector_for_inv( TT_MX *vector, INDEX col );

void system_of_eq( TT_MX *sol, TT_MX *vector, TT_MX *mx );

void do_system_of_eq( TT_MX *sol, TT_MX *vector, TT_MX *mx, TT_MX *L, TT_MX *U );

void set_diag_l( TT_MX *L );

void do_lu_decomp( TT_MX *L, TT_MX *U, TT_MX *mx );

void set_u_element( TT_MX *L, TT_MX *U, TT_MX *mx, INDEX i, INDEX k );

void set_l_element( TT_MX *L, TT_MX *U, TT_MX *mx, INDEX i, INDEX k );

void do_my_system_of_eq( TT_MX *sol, TT_MX *L, TT_MX *U, TT_MX *vector );

void do_system_of_eq_wy_vec( TT_MX *sol, TT_MX *L, TT_MX *U, TT_MX *vector,
  TT_MX *y );

void find_y_system_of_eq( TT_MX *y, TT_MX *L, TT_MX *vector );

void find_sol_vector_system_of_eq( TT_MX *sol, TT_MX *U, TT_MX *y );

void put_column_into_matrix( TT_MX *inv, TT_MX *sol, INDEX col );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void mult_matrices( TT_MX *y, TT_MX *a, TT_MX *b );

void mult_my_matrices( TT_MX *y, TT_MX *a, TT_MX *b );

void mult_matrix_by_scalar( TT_MX *x, float k );




















