
















#include "ext.h"









void do_evolution_tree( void );

void do_my_evolution_tree( void );

ND_LIST *get_evol_tree( ND_LIST *root );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



ND_LIST *get_evol_tree_from_node_tree( ND_LIST *root, NODE_LIST *node_header );

ND_LIST *get_evol_tree_from_single_node_lister( ND_LIST *node, 
  NODE_LIST *node_header );

void set_nd_lister_from_node_lister( ND_LIST *node, NODE_LIST *node_lister );

void revise_evol_tree( ND_LIST *node );

int get_numb_downstream_nodes( ND_LIST *node );

void revise_my_evol_tree_single_downstream_node( ND_LIST *nn, ND_LIST *node, 
  int index, int numb );

void step_evol_tree_nodes( ND_LIST *node, int index, int numb );

void put_short_leaves_into_node( ND_LIST *node, ND_LIST *nn, int index, int numb );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void link_nd_leaves( ND_LIST *root );

STR_LIST *get_str_list_leaf_list( STR_LIST *leaf_header, ND_LIST *node );

STR_LIST *get_str_list_leaf_list_single_leaf( STR_LIST *leaf_header,
  ND_LIST *node );

STR_LIST *put_str_lister_at_end( STR_LIST *header, STR_LIST *new );

void link_nd_leaves_w_label_list( ND_LIST *root, STR_LIST *leaf_header );

void link_nd_leaves_single_leaf_lister_and_step( ND_LIST *root, STR_LIST **leaf );

void link_nd_leaves_single_leaf_lister( ND_LIST *root, STR_LIST *leaf );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



ND_LIST *get_nd_lister_from_label( ND_LIST *root, char label[] );

ND_LIST *get_my_nd_lister_from_label( ND_LIST *node, char label[] );

ND_LIST *get_leaf_from_label( ND_LIST *leaf_header, char label[] );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void print_nd_tree( ND_LIST *root, FILE *fh );

void print_nd( ND_LIST *node, FILE *fh );

void print_my_nd( ND_LIST *node, FILE *fh );

void print_single_daughter_node( ND_LIST *node, FILE *fh );

void print_leaves_of_node( ND_LIST *node, FILE *fh );

void print_nd_leaves( ND_LIST *root, FILE *fh );

ND_LIST *get_nd_leaf_header( ND_LIST *node );

ND_LIST *get_leftest_leaf( ND_LIST *node );

ND_LIST *get_nd_leaf_header_from_leaf( ND_LIST *node );

void print_nd_leaves_leaf_list( ND_LIST *leaf_header, FILE *fh );



















