














#include "ext.h"








void do_evol( void );

void do_my_evol( void );

void do_evol_with_tree( ND_LIST *root );

void do_evol_with_tree_and_leaves( ND_LIST *root, ND_LIST *leaf_header );

PARAM *make_and_initialize_params( PARAM *param );

void do_my_evol_with_params( ND_LIST *root, ND_LIST *leaf_header, PARAM *param );

int do_evol_params_single_iter( ND_LIST *root, ND_LIST *leaf_header, PARAM *param,
  INDEX iter );

int do_evol_tree_w_fh( ND_LIST *root, ND_LIST *leaf_header, PARAM *param, 
  FILE *in );

void put_transition_probs_into_tree( ND_LIST *root, PARAM *param );

void put_transition_probs_into_single_node( ND_LIST *node, PARAM *param );

void put_my_transition_probs_into_single_node( ND_LIST *node, PARAM *param );

void do_evol_w_label_list( ND_LIST *root, ND_LIST *leaf_header, PARAM *param,
  STR_LIST *label_header, FILE *in );

void do_evol_w_label_list_single_gene( ND_LIST *root, ND_LIST *leaf_header,
  PARAM *param, STR_LIST *label_header, char line[] );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void do_evol_fill_phylo( ND_LIST *root, PARAM *param );

void do_evol_fill_phylo_single_node( ND_LIST *node, PARAM *param );

void fill_single_node_w_params( ND_LIST *node, PARAM *param );

void fill_single_node_w_param_probs( ND_LIST *node, PARAM *param );

void fill_single_node_w_param_single_numb_of_mfs( ND_LIST *node, PARAM *param,
  char i );

TT fill_single_node_single_numb_of_mfs_single_down( ND_LIST *node,
  PARAM *param, char i );

TT get_single_node_prob( ND_LIST *node, PARAM *param, char i, char j );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void update_phylo_total_n_vals( ND_LIST *node );

void update_my_phylo_total_n_vals( ND_LIST *node );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void set_prior_probs_w_label_str( ND_LIST *root, ND_LIST *node, 
  ND_LIST *leaf_header, char label[], FILE *fh );

void set_prior_probs_w_spec_node( ND_LIST *root, ND_LIST *node, 
  ND_LIST *leaf_header, ND_LIST *spec, FILE *fh );

void set_prior_probs_w_spec_node_w_mx( ND_LIST *root, ND_LIST *node, ND_LIST *spec,
  ND_LIST *leaf_header, TT_MX *mx, FILE *fh );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void set_prior_probs_w_label_list( ND_LIST *root, ND_LIST *node, 
  ND_LIST *leaf_header, STR_LIST *label_header, ND_LIST *spec, TT_MX *mx, FILE *fh );

void update_counts_for_prior_probs_single_gene( ND_LIST *root, ND_LIST *node,
  ND_LIST *leaf_header, char line[], STR_LIST *label_header, ND_LIST *spec, 
  TT_MX *mx, FILE *fh );

void update_my_counts_for_prior_probs_single_gene( TT_MX *mx, ND_LIST *node );

void set_prior_probs_w_count_mx( ND_LIST *node, TT_MX *mx );

TT get_total_from_tt_mx( TT_MX *mx );

void set_prior_probs_w_count_mx_total( ND_LIST *node, TT_MX *mx, TT total );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



TT get_p( PARAM *param, TT t, INDEX i, INDEX j );

TT get_p_single_k_value( PARAM *param, TT t, INDEX i, INDEX j, INDEX k );

TT get_transition_u( PARAM *param, TT time );

TT get_transition_v( PARAM *param, TT time );

TT get_binom_pr( TT (*pr)( PARAM *pp, TT tt ), INDEX n, INDEX k, PARAM *param, 
  TT t );

TT n_choose_k( INDEX n, INDEX k );






