#include "ft.h"
















/*
#define INPUT_MAF_FNAME "data/ft_hg18/align/hg18.multiz44way.fa.txt"
#define MAJOR_SPEC "hg18"
*/



/*
#define INPUT_MAF_FNAME "data/ft_hg19/align/hg19.multiz46way.fa.txt"
#define MAJOR_SPEC "hg19"
*/





#define INPUT_MAF_FNAME "data/ft_hg19/align/hg19.multiz46way.my_fa.txt"
#define MAJOR_SPEC "hg19"










void do_phylo_formatting( void )
{

  extern char minor_mode;
  
  switch ( minor_mode ) {
  
  case 'a' :
    /*  In gen_coord.c:  */
    do_fasta_to_gencoord_files();
    break;
    
  case 'b' :
    /*  In gen_coord.c:  */
    do_maf_alignment_condensing();
    break;
    
  case 'c' :
    /*  In extract.c:  */
    do_alignment_extraction();
    break;
    
  case 'z' :
    /*  In gene.c:  */
    do_gene_sequence_file_transfer();
    break;
    
  case '\0' :
    error( 1000, "Minor mode not set.  Required for formatting run :  (-M).\n" );
    break;
    
  default :
    error( 1001, "Unknown formatting mode.\n" );
    break;
  
  }

}











void do_occurrence_formatting( void )
{

  extern char minor_mode;
  
  switch ( minor_mode ) {
  
  case 'a' :
    /*  In occur.c:  */
    do_occur_ft();
    break;
    
  case 'b' :
    /*  In this file, below:  */
    do_gene_label_binary_file();
    break;
    
  case 'c' :
    /*  In my_occur.c:  */
    do_binary_occur_ft();
    break;
    
  case 'd' :
    /*  In gene.c:  */
    do_gene_numb_of_orthologs();
    break;
    
  case 'z' :
    /*  In my_gen_coord.c:  */
    do_gen_coord_files();
    break;
    
  default :
    error( 1002, "Unknown occurrence formatting mode.\n" );
    break;
  
  }

}













void do_gene_label_binary_file( void )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *in = NULL;
  in = (FILE *)open_text_file_reading( INPUT_MAF_FNAME, "" );
  
  /*  In my_occur.c:  */
  set_gene_label_binary_file( MAJOR_SPEC, in );
  
  close_file( in );

}



















