












#include "../ext/struct.h"









typedef struct ft_struct {
  FILE *ft;
  FILE *ind;
  FILE *label;
  FILE *pos;
  FILE *ind_pos;
} FH;



















void do_binary_occur_ft( void );

void do_my_binary_occur_ft( void );

void do_binary_occur_ft_w_input( FILE *in );

void set_gene_label_binary_file( char spec[], FILE *in );

void do_gene_label_binary_file_w_fh( char spec[], FILE *in, FH *my_fh );

void get_gene_label_binary_entry_single_line( char line[], char seq[], 
  char label[], char spec[], SEQ *seq_numb, FH *my_fh );

void get_my_gene_label_binary_entry_single_line( char line[], char seq[],
  char label[], char spec[], SEQ *seq_numb, FH *my_fh );

void new_gene_label_binary_sequence( char seq[], SEQ seq_numb, char label_line[],
  FH *my_fh );

void get_and_put_gene_name_from_label_line( GENE_LABEL *label, char label_line[] );

COORD get_alignment_tss_column_numb( char seq[] );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



void do_binary_occur_ft_w_species_list( STR_LIST *spec_header, FILE *in );

void do_binary_occur_ft_single_spec_and_step( STR_LIST **spec, FILE *in );

void do_binary_occur_ft_single_spec( STR_LIST *spec, FILE *in );

void do_my_binary_occur_ft_single_spec( STR_LIST *spec, FILE *in );

void do_binary_occur_ft_single_spec_w_fhs( char spec[], FILE *in, FH *my_fh );

OCCUR_IND_CELL *set_occur_ind_cell_from_ind_file( OCCUR_IND_CELL *occur_cell,
  FH *my_fh );

void set_single_occur_ind_struct_from_ind_file( OCCUR_IND *my_occur, FH *my_fh );

void do_binary_occur_ft_single_spec_w_occur_ind_cell( OCCUR_IND_CELL *occur_cell,
  char spec[], FILE *in, FH *my_fh );

void do_binary_occur_ft_single_spec_single_line( OCCUR_IND_CELL *occur_cell,
  GENE_LABEL *gene_label, char line[], char seq[], char spec[], FH *my_fh );

void do_my_binary_occur_ft_single_spec_single_line( OCCUR_IND_CELL *occur_cell,
  GENE_LABEL *gene_label, char line[], char seq[], char spec[], FH *my_fh );

void do_binary_occur_ft_sequence_update( char line[], char seq[], char spec[] );

void do_binary_occur_ft_matching_spec_seq_update( char seq[], char curr_seq[] );



/*========================================================================*/
/*========================================================================*/
/*========================================================================*/



void get_and_put_binary_sequence_info_occur_struct( OCCUR_IND_CELL *occur_cell,
  GENE_LABEL *gene_label, char seq[], FH *my_fh );

void get_and_put_binary_seq_info_occur_two_seqs( OCCUR_IND_CELL *occur_cell,
  char pure_seq[], char seq[], GENE_LABEL *gene_label, FH *my_fh );

COORD get_relative_site_tss_column( char seq[], COORD tss );

void get_and_put_binary_seq_info_w_start_indices( OCCUR_IND_CELL *occur_cell, 
  char pure_seq[], char seq[], GENE_LABEL *gene_label, COORD rel_align_tss, 
  COORD rel_site_tss, FH *my_fh );

void get_and_put_binary_seq_info_single_mf( OCCUR_IND_CELL *occur_cell,
  char pure_seq[], char seq[], GENE_LABEL *gene_label, int align_index,
  int *pure_index, int *pure_nucl, COORD align_pos, COORD *site_pos, MF *numb, 
  FH *fh );

void do_binary_seq_single_nucl_is_nucl( OCCUR_IND_CELL *occur_cell, char pure_seq[],
  char seq[], GENE_LABEL *gene_label, int align_index, int pure_index,
  int pure_nucl, COORD align_pos, COORD site_pos, MF *numb, FH *fh );

MF get_motif_numb_binary_seq( char pure_seq[], int align_index, int pure_index, 
  int pure_nucl, MF numb );

void do_binary_seq_single_nucl_motif_numb( OCCUR_IND_CELL *occur_cell,
  MF numb, COORD align_pos, COORD site_pos, GENE_LABEL *gene_label, FH *fh );

void put_binary_occur_info_ft_file( COORD align_pos, COORD site_pos,
  GENE_LABEL *gene_label, FH *fh );



/*========================================================================*/
/*========================================================================*/
/*========================================================================*/



void do_position_align_nucls( char seq[], SEQ seq_numb, GENE_LABEL *gene, 
  FH *my_fh );

void get_position_align_nucls_occur_ind( OCCUR_IND *my_index, char seq[], 
  FH *my_fh );

void do_position_align_nucls_w_sequence( char seq[], SEQ seq_numb,
  GENE_LABEL *gene, FH *my_fh );

void do_position_align_nucls_w_sequence_bp( SEQ seq_numb, GENE_LABEL *gene,
  COORD column, COORD pos, FH *my_fh );



/*========================================================================*/
/*========================================================================*/
/*========================================================================*/



void check_occur_cell_counts( OCCUR_IND_CELL *occur_cell, FH *my_fh );

void check_occur_cell_single_count( OCCUR_IND *occur, FH *my_fh );





















