
















#include "../ext/struct.h"









typedef struct my_list_struct {

  SLIST *total;
  
  SLIST *all_and_all;

  SLIST *all_and_c;

  SLIST *a_and_c;
  SLIST *a_and_no_c;
  SLIST *no_a_and_c;
  SLIST *a_no_c_and_c;
  SLIST *a_and_a_no_c;

  SLIST *c_no_a_and_c;
  SLIST *c_and_c;

} MY_LIST;








void do_gene_enrich( void );

SLIST *get_go_category_list_w_fname( SLIST *term_header, char fname[] );

SLIST *get_go_category_list_w_fh( SLIST *term_header, FILE *in );

SLIST *get_go_category_single_entry( SLIST *term_header, char line[], FILE *in );

int get_numb_of_lines_until_sep( FILE *in );

SLIST *make_and_put_go_cat( SLIST *term_header, char term[] );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void do_gene_enrich_w_go_list( SLIST *term_header, char list_base[],
  char go_gene_fname[], char go_term_fname[], char output_fname[] );

void do_gene_enrich_w_fh( SLIST *term_header, char list_base[], char go_gene_fname[],
  char go_term_fname[], FILE *out );

void get_my_list_gene_enrich( MY_LIST *my_list, char list_base[] );

SLIST *get_total_gene_list( SLIST *header, char fname[] );

SLIST *get_total_gene_list_fh( SLIST *header, FILE *in );

SLIST *get_total_gene_list_my_single_line( SLIST *header, char line[] );

void do_gene_enrich_w_gene_lists( MY_LIST *my_list, SLIST *term_header,
  char go_gene_fname[], char go_term_fname[], FILE *out );

GO_CAT_LIST *get_go_enrich_list( GO_CAT_LIST *go_header, MY_LIST *my_list,
  SLIST *term_header, char go_gene_fname[] );

GO_CAT_LIST *get_go_enrich_list_w_fh( GO_CAT_LIST *go_header, MY_LIST *my_list,
  SLIST *term_header, FILE *in );

GO_CAT_LIST *get_go_enrich_list_single_entry( GO_CAT_LIST *go_header, 
  MY_LIST *my_list, SLIST *term_header, char x, FILE *in );

int str_in_my_slist( char str[], SLIST *header );

GO_CAT_LIST *empty_entry_go_enrich( GO_CAT_LIST *go_header, FILE *in );

GO_CAT_LIST *get_my_go_enrich_list_single_entry( GO_CAT_LIST *go_header, char term[], 
  MY_LIST *my_list, FILE *in );

GO_CAT_LIST *make_and_put_go_enrich_w_go_gene_slist( GO_CAT_LIST *go, 
  MY_LIST *my_list, char term[], SLIST *go_gene_header );

int get_intersection_three_slists( SLIST *a_header, SLIST *b_header, 
  SLIST *c_header );

GO_CAT_LIST *put_go_cat_lister_into_sorted_list( GO_CAT_LIST *go_header, 
  GO_CAT_LIST *go );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void do_gene_enrich_w_go_category_list( GO_CAT_LIST *go_header, MY_LIST *my_list, 
  char go_gene_fname[], char go_term_fname[], FILE *out );

void do_gene_enrich_go_cat_list_single_go_and_step( GO_CAT_LIST **go,
  MY_LIST *my_list, char go_gene_fname[], char go_term_fname[], FILE *out );

void do_gene_enrich_go_cat_list_single_go( GO_CAT_LIST *go, MY_LIST *my_list,
  char go_gene_fname[], char go_term_fname[], FILE *out );

void do_my_gene_enrich_go_cat_list_single_go( GO_CAT_LIST *go, MY_LIST *my_list,
  char go_gene_fname[], char go_term_fname[], FILE *out );

void do_gene_enrich_single_go_cat( GO_CAT_LIST *go, MY_LIST *my_list,
  char go_gene_fname[], FILE *out );

void do_gene_enrich_single_go_cat_w_gene_list( GO_CAT_LIST *go, MY_LIST *my_list,
  SLIST *go_gene_header, FILE *out );

void print_gene_enrich_go_cat_lister( GO_CAT_LIST *go, FILE *out );

void do_my_enrich_single_go_cat_w_gene_list( GO_CAT_LIST *go, MY_LIST *my_list, 
  SLIST *all_header, char x[], SLIST *go_gene_header, FILE *out );

void print_enrich_single_go_cat_single_list( char x[], SLIST *gene_header,
  SLIST *all_header, SLIST *go_gene_header, FILE *out );



















