














#include "../ext/struct.h"













void do_format_methyl( void );

void do_format_methyl_single_cell_line( char cell_line[], char dir[], 
  char fasta_fname[] );

SLIST *get_chr_list_methyl_all_file( SLIST *chr_header, char cell_line[], 
  char dir[] );

SLIST *get_chr_list_methyl_all_fh( SLIST *chr_header, FILE *in );

SLIST *get_chr_list_methyl_single_line( SLIST *chr_header, char line[] );

SLIST *get_my_chr_list_methyl_single_line( SLIST *chr_header, char line[] );

int str_in_slist( SLIST *header, char str[] );

SLIST *make_and_put_new_slister_end_of_list( SLIST *chr_header, char chr[] );

void print_slist( SLIST *header );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



void do_format_methyl_single_cell_line_chr_list( SLIST *chr_header, char cell_line[],
  char dir[], char fasta_fname[] );

void do_format_methyl_single_cell_line_w_fhs( SLIST *chr_header, char cell_line[],
  char dir[], FILE *fasta_fh, FILE *out );

void do_format_methyl_single_chr_and_step( SLIST **chr, char cell_line[], 
  char dir[], int *seq_index, FILE *fasta_fh, FILE *out );

void do_format_methyl_single_chr( SLIST *chr, char cell_line[], char dir[],
  int *seq_index, FILE *fasta_fh, FILE *out );

void do_format_methyl_single_chr_w_fh( SLIST *chr, int *seq_index, FILE *methyl_fh, 
  FILE *fasta_fh, FILE *out );

void do_format_methyl_single_gene( GENCOORD_ENTRY *my_entry, SLIST *chr,
  int seq_numb, int *seq_index, FILE *methyl_fh, FILE *out );

void do_my_format_methyl_single_gene( GENCOORD_ENTRY *my_entry, int prom_start, 
  int prom_end, int seq_numb, int *seq_index, FILE *methyl_fh, FILE *out );

int do_format_methyl_single_methyl_region( GENCOORD_ENTRY *my_entry, char line[], 
  int prom_start, int prom_end, int seq_numb, int *seq_index, FILE *out );

void get_gene_from_acc_gene_info_file( char my_gene[], char acc[], char fname[] );

void get_gene_from_acc_gene_info_fh( char my_gene[], char acc[], FILE *in );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



void do_cpg_island_format( void );

void do_cpg_island_format_w_fhs( FILE *cpg_fh, FILE *fasta_fh, FILE *out );

void do_cpg_island_format_single_gene( GENCOORD_ENTRY *my_entry, int seq_numb,
  int *seq_index, FILE *cpg_fh, FILE *out );

int gene_is_in_cpg_island( GENCOORD_ENTRY *my_entry, FILE *cpg_fh );

int cpg_island_line_in_promoter( char line[], GENCOORD_ENTRY *my_entry );

int cpg_island_in_start_end_region( char line[], int prom_start, int prom_end );




















