














#include "../ext/struct.h"










typedef struct list_struct {

  SLIST *all_and_c;

  SLIST *a_and_c;
  SLIST *no_a_and_c;
  SLIST *a_and_no_c;
  SLIST *no_a_and_no_c;
  
  SLIST *c_no_a_and_c;
  SLIST *c_and_c;
  
  SLIST *a_no_c_and_c;
  
  SLIST *a_and_a_no_c;
  
  SLIST *total;
  
} LIST;





typedef struct spec_list_struct {
  SLIST *c_and_c;
  SLIST *no_c_and_c;
  SLIST *c_and_no_c;
} SPEC_LIST;











void do_sep_methyl_seq( void );

void set_sep_methyl_seq_lists( LIST *my_list );

void do_my_sep_methyl_seq( LIST *my_list, SPEC_LIST *spec_list, char dir[] );

void do_sep_methyl_seq_w_output_fh( LIST *my_list, SPEC_LIST *spec_list,
  char dir[], FILE *out );

void do_sep_methyl_seq_single_cell_line( LIST *my_list, SPEC_LIST *spec_list,
  char cell_line[], char dir[], FILE *out );

SLIST *get_methyl_slist_cell_line( SLIST *methyl_header, char cell_line[],
  char dir[] );

SLIST *get_methyl_slist_cell_line_w_fh( SLIST *methyl_header, FILE *fh );

SLIST *get_methyl_slist_single_line( SLIST *methyl_header, char line[] );

SLIST *make_and_put_methyl_slister( SLIST *methyl_header, char acc[] );

SLIST *get_total_methyl_slist_cell_line( SLIST *total_methyl, char cell_line[], 
  char dir[] );

SLIST *get_total_methyl_slist_cell_line_w_fh( SLIST *total_methyl, FILE *fh );

SLIST *get_total_methyl_slist_single_line( SLIST *total_methyl, char line[] );

int get_total_lines_in_methyl_file( char dir[], char cell_line[] );

void do_sep_methyl_seq_w_methyl_gene_list( LIST *my_list, SPEC_LIST *spec_list,
  SLIST *methyl_header, SLIST *total_methyl, char cell_line[], FILE *out );

void do_total_sep_methyl_gene_list( LIST *my_list, SLIST *methyl_header, 
  SLIST *total_methyl, FILE *out );

void do_my_total_sep_methyl_gene_list( SLIST *gc_header, SLIST *methyl_header,
  SLIST *total_methyl, FILE *out );

void do_sep_methyl_seq_single_gene_list( char x[], SLIST *gene_header,
  SLIST *methyl_header, SLIST *total_methyl, FILE *out );



/*========================================================================*/
/*========================================================================*/
/*========================================================================*/



void do_sep_cpg_islands_output_fh( LIST *my_list, SPEC_LIST *spec_list, char fname[], 
  FILE *out );

void do_sep_cpg_islands_w_fhs( LIST *my_list, SPEC_LIST *spec_list, FILE *in, 
  FILE *out );

void do_sep_cpg_islands_w_gene_list( LIST *my_list, SPEC_LIST *spec_list,
  SLIST *cpg_header, FILE *out );

int get_total_genes_fasta_file( char fname[] );

int get_total_genes_w_fh( FILE *in );

void put_sep_cpg_islands( LIST *my_list, SPEC_LIST *spec_list, SLIST *cpg_header, 
  int total_genes, FILE *out );













