
















#include "../ext/struct.h"











void do_total_enrich( void );

SLIST *get_total_genes_from_input_fname( SLIST *total_genes, char spec_one[],
  char spec_two[], char fname[] );

SLIST *get_total_genes_from_fh( SLIST *total_genes, char spec_one[],
  char spec_two[], FILE *in );

SLIST *get_total_genes_w_label_list( SLIST *total_genes, STR_LIST *label_header,
  char spec_one[], char spec_two[], FILE *in );

SLIST *get_total_genes_single_line( SLIST *total_genes, STR_LIST *label_header,
  char spec_one[], char spec_two[], char line[] );

int gene_exists_in_col_line( char spec[], STR_LIST *label_header, char line[] );

int gene_exists_in_single_column_and_step( STR_LIST **label, char line[], 
  char spec[], INDEX *index );

int gene_exists_in_single_column( STR_LIST *label, char line[], char spec[],
  INDEX *index );

SLIST *get_genes_w_motif_type( SLIST *gene_header, char fname[], char spec_one[],
  char spec_two[], char my_nucl );

SLIST *get_genes_motif_type_w_fh( SLIST *gene_header, char spec_one[],
  char spec_two[], char my_nucl, FILE *in );

SLIST *get_genes_motif_type_w_label_list( SLIST *gene_header, STR_LIST *label_header, 
  char spec_one[], char spec_two[], char my_nucl, FILE *in );

SLIST *get_genes_motif_type_single_line( SLIST *gene_header, STR_LIST *label_header,
  char line[], char spec_one[], char spec_two[], char my_nucl );

int motif_type_in_col_line( STR_LIST *label_header, char line[], char spec[], 
  char my_nucl );

int motif_type_in_single_column_and_step( STR_LIST **label, char line[], char spec[],
  INDEX *index, char my_nucl );

int motif_type_in_single_column( STR_LIST *label, char line[], char spec[],
  INDEX *index, char my_nucl );

SLIST *make_and_put_gene_into_slist( SLIST *gene_header, char gene[] );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void do_total_enrich_w_gene_lists( SLIST *gene_header, SLIST *total_genes, 
  char go_gene_fname[], char go_term_fname[], char output_fname[] );

void do_total_enrich_w_gene_lists_fhs( SLIST *gene_header, SLIST *total_genes,
  char go_term_fname[], FILE *in, FILE *out );

void do_my_total_enrich_w_gene_lists( SLIST *term_header, SLIST *gene_header,
  SLIST *total_genes, char go_term_fname[], FILE *in, FILE *out );

GO_CAT_LIST *get_go_cat_list_total_enrich( GO_CAT_LIST *go_header,
  SLIST *term_header, SLIST *gene_header, SLIST *total_genes, FILE *in );

GO_CAT_LIST *get_go_cat_list_single_term_and_step( GO_CAT_LIST *go_header,
  SLIST **term, SLIST *gene_header, SLIST *total_genes, FILE *in );

GO_CAT_LIST *get_go_cat_list_single_term( GO_CAT_LIST *go_header, SLIST *term,
  SLIST *gene_header, SLIST *total_genes, FILE *in );

SLIST *get_go_gene_list_total( SLIST *go_gene_header, SLIST *term, FILE *in );

GO_CAT_LIST *get_my_go_cat_list_single_term( GO_CAT_LIST *go_header,
  SLIST *term, SLIST *go_gene_header, SLIST *gene_header, SLIST *total_genes );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void print_go_cat_list_total( GO_CAT_LIST *go_header, SLIST *gene_header, 
  char go_term_fname[], FILE *out );

void print_my_go_cat_list_total( GO_CAT_LIST *go_header, char go_term_fname[],
  FILE *out );

void print_go_cat_list_total_single_go_and_step( GO_CAT_LIST **go, 
  char go_term_fname[], FILE *out );

void print_go_cat_list_total_single_go( GO_CAT_LIST *go, char go_term_fname[],
  FILE *out );














