















#include "../ext/struct.h"











typedef struct my_list_struct {
  
  SLIST *all_and_c;
  
  SLIST *c_and_c;
  SLIST *c_and_no_c;
  SLIST *no_c_and_c;
  
  SLIST *total;
  
} MY_LIST;









void do_two_node_enrich( void );

void do_my_two_node_enrich( SLIST *term_header, char total_gene_list_base[],
  char gene_list_base[], char go_gene_fname[], char go_term_fname[], 
  char output_fname[] );

void do_two_node_enrich_w_output_fh( SLIST *term_header, char total_list_base[],
  char list_base[], char go_gene_fname[], char go_term_fname[], FILE *out );

void get_list_two_node_enrich( MY_LIST *my_list, char total_list_base[],
  char list_base[] );

void do_two_node_enrich_w_gene_lists( SLIST *term_header, MY_LIST *my_list, 
  char go_gene_fname[], char go_term_fname[], FILE *out );

GO_CAT_LIST *get_go_enrich_list_two_node( GO_CAT_LIST *go_header, SLIST *term_header,
  MY_LIST *my_list, char go_gene_fname[] );

GO_CAT_LIST *get_go_enrich_list_two_node_w_fh( GO_CAT_LIST *go_header, 
  SLIST *term_header, MY_LIST *my_list, FILE *in );

GO_CAT_LIST *get_go_enrich_two_node_single_entry( GO_CAT_LIST *go_header,
  MY_LIST *my_list, SLIST *term_header, char x, FILE *in );

GO_CAT_LIST *get_go_enrich_two_node_single_correct_entry( GO_CAT_LIST *go_header,
  char term[], MY_LIST *my_list, FILE *in );

GO_CAT_LIST *make_and_put_go_enrich_two_node_gene_slist( GO_CAT_LIST *go,
  MY_LIST *my_list, char term[], SLIST *go_gene_header );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void do_gene_two_node_enrich_w_go_cat_list( GO_CAT_LIST *go_header, 
  MY_LIST *my_list, char go_gene_fname[], char go_term_fname[], FILE *out );

void do_gene_two_node_enrich_single_go_and_step( GO_CAT_LIST **go, MY_LIST *my_list,
  char go_gene_fname[], char go_term_fname[], FILE *out );

void do_gene_two_node_enrich_single_go( GO_CAT_LIST *go, MY_LIST *my_list,
  char go_gene_fname[], char go_term_fname[], FILE *out );

void do_my_gene_two_node_enrich_single_go( GO_CAT_LIST *go, MY_LIST *my_list,
  char go_gene_fname[], char go_term_fname[], FILE *out );

void do_gene_two_node_enrich_single_go_cat( GO_CAT_LIST *go, MY_LIST *my_list,
  char go_gene_fname[], FILE *out );

void do_gene_two_node_enrich_single_go_w_gene_list( GO_CAT_LIST *go,
  MY_LIST *my_list, SLIST *go_gene_header, FILE *out );

void do_my_gene_two_node_enrich_single_go_w_gene_list( GO_CAT_LIST *go,
  MY_LIST *my_list, SLIST *go_gene_header, FILE *out );


























