















#include "../ext/struct.h"













void do_ancestral_nucls( void );

void do_ancestral_nucls_w_node_phylo( NODE_LIST *node_header );

void do_my_ancestral_nucls_w_node_phylo( NODE_LIST *node_header );

void do_ancestral_nucls_phylo_w_leaf_list( NODE_LIST *node_header,
  NODE_LIST *leaf_header );

void make_nucl_co_occur_tree_data( NODE_LIST *node );

void make_nucl_co_occur_tree_data_recursion( NODE_LIST *node );

void make_nucl_co_occur_node_data( NODE_LIST *leaf_header );

void make_nucl_co_occur_matrix_single_leaf_and_step( NODE_LIST **leaf );

void make_nucl_co_occur_matrix_single_leaf( NODE_LIST *leaf );

INDEX get_numb_of_upstream_nodes( NODE_LIST *leaf );

void do_my_ancestral_nucls_phylo_w_leaf_list( NODE_LIST *node_header,
  NODE_LIST *leaf_header, FPOS_CELL *fpos_cell );

int do_ancestral_nucls_leaf_list_single_gene( NODE_LIST *node_header,
  NODE_LIST *leaf_header, FPOS_CELL *fpos_cell, SEQ seq_numb );

void initialize_ancestral_nucls( NODE_LIST *node );

void initialize_my_ancestral_nucls( NODE_LIST *node );

int do_ancestral_nucls_single_leaf_and_step( NODE_LIST **leaf, FPOS_CELL *fpos_cell, 
  SEQ seq_numb, INDEX spec_numb );

int do_ancestral_nucls_single_leaf( NODE_LIST *leaf, FPOS_CELL *fpos_cell,
  SEQ seq_numb, INDEX spec_numb );

int do_ancestral_nucls_single_leaf_w_fh( NODE_LIST *leaf, FPOS_CELL *fpos_cell,
  SEQ seq_numb, INDEX spec_numb, FILE *in );

void do_ancestral_nucls_single_leaf_single_line( NODE_LIST *leaf, SEQ seq_numb,
  char line[] );

void set_single_leaf_w_line_data( NODE_LIST *leaf, char nucl_occur[] );

char get_leaf_single_nucl( char my_nucl );

void set_node_data_total_vals( NODE_LIST *node );

void set_node_data_total_vals_single_node( NODE_LIST *node );

void get_node_data_total_vals_single_ancestor( NODE_LIST *node, INDEX spec_numb );

COUNT get_node_data_total_single_mx( NODE_LIST *node, COUNT *mx );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void do_ancestral_nucls_all_nodes_set_leaves( NODE_LIST *node_header );

void do_my_ancestral_nucls_all_nodes( NODE_LIST *node );

void do_ancestral_nucls_all_nodes_down_to_up( NODE_LIST *node );

void set_ancestral_nucl_array_from_downstream_nodes( NODE_LIST *node, 
  NODE_LIST *down_nodes[] );

void set_ancestral_nucl_array_single_site( NODE_LIST *node, NODE_LIST *down_nodes[], 
  char nucl );

char update_ancestral_nucl_downstream_node( char curr_node, char down_node );

char update_my_ancestral_nucl_downstream_node( char curr_node, char down_node );

char update_ancestral_nucl_phylo_absent( char nucl );

char update_ancestral_nucl_phylo_present( char nucl );

char update_ancestral_nucl_phylo_unknown( char nucl );

char update_ancestral_nucl_phylo_no_ortho( char nucl );

void do_ancestral_nucls_all_nodes_up_to_down( NODE_LIST *node );

void do_ancestral_nucls_up_to_down_recursion( NODE_LIST *node );

void do_my_ancestral_nucls_up_to_down( NODE_LIST *node );

void do_ancestral_nucls_up_to_down_single_nucl( NODE_LIST *node, char nucl );

char nucl_up_to_down( char up_nucl, char curr_nucl );

void update_tree_co_occur_data_single_gene( NODE_LIST *node );

void update_tree_co_occur_data_single_gene_recursion( NODE_LIST *node );

void update_leaf_co_occur_data_single_gene( NODE_LIST *leaf_header );

void update_leaf_co_occur_data_single_leaf_and_step( NODE_LIST **leaf );

void update_leaf_co_occur_data_single_leaf( NODE_LIST *leaf );

void update_leaf_co_occur_data_upstream_node_and_step( NODE_LIST *leaf,
  NODE_LIST **node, INDEX spec_numb );

void update_leaf_co_occur_data_upstream_node( NODE_LIST *leaf, NODE_LIST *node,
  INDEX spec_numb );

void update_leaf_co_occur_data_upstream_node_matrix( NODE_LIST *leaf,
  NODE_LIST *node, COUNT *mx );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void get_ancetral_phylo_column_data_fname( char fname[], char spec[] );












