















#include "../ext/struct.h"
#include "ext_tr.h"















typedef struct fh_conv_struct {
  FILE *out_bird;
  FILE *out_mouse;
} FH_CONV;






void do_gc_box_converge_sep( void );

void do_my_gc_box_converge_sep( void );

void do_gc_converge_sep_w_node_tree( NODE_LIST *node_header );

SEP_LIST *make_sep_list_gc_conv( SEP_LIST *sep_header );

void set_ft_conv( FH_CONV *my_fh );

void close_ft_conv( FH_CONV *my_fh );

void do_gc_converge_sep_w_conv_sep_struct( SEP_LIST *my_sep,
  NODE_LIST *node_header, FH_CONV *my_fh );

void do_gc_converge_sep_w_leaf_list( SEP_LIST *my_conv, NODE_LIST *node_header,
  NODE_LIST *leaf_header, FH_CONV *my_fh );

void do_gc_converge_sep_w_all( SEP_LIST *my_conv, NODE_LIST *node_header,
  NODE_LIST *leaf_header, FPOS_CELL *fpos_cell, FH_CONV *my_fh );

int do_gc_converge_sep_single_gene( SEP_LIST *my_conv, NODE_LIST *node_header,
  NODE_LIST *leaf_header, FPOS_CELL *fpos_cell, SEQ seq_numb, FH_CONV *my_fh );

int do_gc_converge_sep_single_gene_blank_leaves( SEP_LIST *my_conv,
  NODE_LIST *node_header, NODE_LIST *leaf_header, FPOS_CELL *fpos_cell, SEQ seq_numb, 
  FH_CONV *my_fh );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



void do_gc_converge_sep_single_gene_phylo_info( SEP_LIST *my_conv,
  NODE_LIST *node_header, NODE_LIST *leaf_header, SEQ seq_numb, FH_CONV *my_fh );

void set_spec_struct( SPEC *my_spec, NODE_LIST *node_header );

void initialize_spec_struct( SPEC *my_spec );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/















