
















#include "../ext/struct.h"









typedef struct fh_struct {
  FILE *ft_fh;
  FILE *ind_fh;
  FILE *label_fh;
  FILE *align_fh;
} FH;












void do_individual_spec_text_ft( void );

void do_my_individual_spec_text_ft_all( void );

void do_individual_spec_text_ft_w_spec_list( STR_LIST *spec_header );

void do_individual_spec_text_ft_single_spec_and_step( STR_LIST **spec );

void do_individual_spec_text_ft_single_spec( STR_LIST *spec );

void do_individual_spec_text_ft_w_fnames( char fname_base[], char out_fname[] );

void do_individual_spec_text_ft_out_fh( char fname_base[], MOTIF *mf, FILE *out );

GENE_LIST *get_individual_spec_gene_list( GENE_LIST *gene_header, char fname_base[],
  MOTIF *mf );

void put_individual_spec_text_ft( GENE_LIST *gene_header, char fname_base[], 
  MOTIF *mf, FILE *out );

void put_individual_spec_text_ft_w_fhs( GENE_LIST *gene_header, char fname_base[],
  MOTIF *mf, FH *my_fh, FILE *out );

void put_my_individual_spec_text_ft_w_fhs( GENE_LIST *gene_header, MOTIF *mf, 
  FH *my_fh, FILE *out );

void put_individual_spec_text_single_gene( GENE_LIST *gene_header,
  GENE_LABEL *my_gene, MOTIF *mf, SEQ seq_numb, FH *my_fh, FILE *out );

int spec_has_gene( FILE *align_fh );

void put_my_individual_spec_text_single_gene( GENE_LIST *gene_header, 
  GENE_LABEL *my_gene, MOTIF *mf, SEQ seq_numb, FH *my_fh, FILE *out );

void put_matching_gene_lister_spec_column_fh( GENE_LIST *gene, MOTIF *mf,
  FH *my_fh, FILE *out );

void put_my_matching_gene_lister_spec_column_fh( GENE_LIST *gene, char nucl[],
  WIND *my_wind, MOTIF *mf, FH *my_fh, FILE *out );

void put_matching_gene_lister_w_wind( GENE_LIST *gene, WIND *column_wind,
  char nucl[], WIND *my_wind, MOTIF *mf, FILE *out );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



void get_input_fname_base_for_spec_text_ft( char fname[], char spec[] );

void get_output_fname_base_for_spec_text_ft( char out_fname[], char fname_base[] );





















