#include "main.h"





















int main( int argc, char *argv[] )
{

  printf( "\n" );
  printf( "Running program...\n\n" );
  
  my_main( argc, argv );
  
  printf( "\nProgram complete.\n\n" );
  
  return 0;

}











void my_main( int argc, char *argv[] )
{

  /*  In param.c:  */
  set_params( argc, argv );
  
  /*  In this file, below:  */
  do_main_w_params();

}













void do_main_w_params( void )
{

  extern char mode;
  
  switch ( mode ) {
  
  case 'v' :
    /*  In ../values/values.c:  */
    do_values();
    break;
    
  case 'm' :
    /*  In ../model/model.c:  */
    do_model();
    break;

  case 'n' :
    /*  In ../new/new.c:  */
    do_new_model();
    break;
    
  default :
    error( 1, "Unrecognized value for mode.\n" );
    break;
  
  }

}













void error( int numb, char str[] )
{

  printf( "Error numb :  %d\n", numb );
  printf( "%s\n", str );
  
  exit( numb );

}












void print_sep( FILE *fh )
{

  int i = 0;
  
  while ( i++ < 50 )
    fprintf( fh, "=" );
    
  fprintf( fh, "\n" );

}










