#include "parse.h"






















int get_entry_index_from_str( char line[], char str[] )
{

  int entry_numb = 0;
  int is_space = 1;
  
  register int i = 0;
  
  while ( line[ i ] != '\0' ) {
  
    if (( ! isspace( line[ i ] )) && ( is_space )) {
    
      ++entry_numb;
      
      is_space = 0;
      
      char entry[ BUFFER ];
      sscanf( line + i, "%s", entry );
      
      if ( ! strcmp( str, entry ))
        return entry_numb;
    
    }
    
    if ( isspace( line[ i ] ))
      is_space = 1;
      
    ++i;
  
  }

  return -1;

}










void get_entry_from_index( char entry[], char line[], int index )
{

  int entry_numb = 0;
  int is_space = 1;
  
  register int i = 0;
  
  while ( line[ i ] != '\0' ) {
  
    if (( ! isspace( line[ i ] )) && ( is_space )) {
    
      if ( ++entry_numb == index )
        break;
        
      is_space = 0;
    
    }
    
    if ( isspace( line[ i ] ))
      is_space = 1;
    
    ++i;
  
  }
  
  sscanf( line + i, "%s", entry );

}











int get_nucl_entry_count( char entry[], char numb )
{

  int i = 0, underscores = 0;
  
  while ( entry[ i ] != '\0' ) {
  
    if ( underscores == numb ) {

      char numb_str[ BUFFER ];

      int j = 0;

      while ( entry[ i ] != '_' )
        numb_str[ j++ ] = entry[ i++ ];
        
      numb_str[ j ] = '\0';
      
      if ( ! strcmp( numb_str, "-" ))
        return -1;
      
      return atoi( numb_str );

    }
    
    if ( entry[ i ] == '_' )
      ++underscores;
      
    ++i;
  
  }

}






















