

















#include "../ext/struct.h"











void do_deterministic( void );

void do_my_deterministic( GG *my_gg );

void do_deter_w_fh( GG *my_gg, FILE *out );

void do_my_deter_w_fh( GG *my_gg, FILE *out );

void initialize_deter_gg( GG *my_gg );

void initialize_deter_gg_y_matrix( STAT_CELL *y );

void set_deter_w_matrix( GG *my_gg );

void set_deter_w_matrix_pq( STAT_CELL *w, STAT p, STAT q );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void do_deter_single_generation( GG *my_gg, int t, FILE *out );

void update_deter_single_gen_loci( GG *my_gg, GG *gg );

void update_my_deter_single_gen_loci( GG *my_gg, GG *gg );

void update_deter_single_gen_single_locus( GG *my_gg, GG *gg, int a );

STAT get_avg_fitness_deter_single_locus( STAT_CELL *y, STAT_CELL *w, int a );

void update_deter_single_gen_single_locus_single_hapl( GG *my_gg, GG *gg, 
  STAT avg_fitness, int x, int a );

STAT get_sum_fitness_locus( GG *my_gg, int x, int a );

void update_deter_single_gen_pq( GG *my_gg, GG *gg );

STAT get_lval( STAT_CELL *y, char a, char b );

STAT get_pr_lval_single_term( STAT_CELL *y, char a, char b, int j );

STAT get_ww_val( STAT a, STAT b, STAT x, STAT y );

void update_deter_single_gen_mutation( GG *gg );

void update_deter_single_gen_mutation_w_mx( GG *gg, STAT_CELL *mx, STAT_CELL *a, 
  STAT_CELL *b );

void set_deter_transition_mx( STAT_CELL *x );

void update_my_deter_single_gen_mutation_w_mx( GG *gg, STAT_CELL *mx, STAT_CELL *a, 
  STAT_CELL *b );

void update_my_deter_single_gen_mutation_single_locus( GG *gg, STAT_CELL *mx, 
  STAT_CELL *a, STAT_CELL *b, int j );

void set_deter_freq_vector_single_locus( STAT_CELL *a, GG *my_gg, int j );

void multiply_matrices( STAT_CELL *c, STAT_CELL *a, STAT_CELL *b );

void copy_deter_freq_vector_y_mx( STAT_CELL *y, STAT_CELL *b, int j );

void update_deter_single_gen_freq( GG *gg );

void update_deter_single_gen_freq_single_locus( GG *gg, int j );

STAT copy_gg( GG *my_gg, GG *gg );

void copy_stat_cell_matrix( STAT_CELL *a, STAT_CELL *b );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void print_deter_header_comments( FILE *out );

void print_deter_gg( GG *my_gg, int t, FILE *out );

void print_my_deter_gg( GG *my_gg, int t, FILE *out );











