




















#include "../ext/struct.h"








void do_partition_model( void );

void initialize_params_partition( PARAMS *my_params );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



void do_my_partition_model( PARAMS *my_params );

INFO *set_partition_info( INFO *my_info, PARAMS *my_params );

INFO *set_my_partition_info( INFO *my_info, PARAMS *my_params );

void set_partition_part_cell( PART_CELL *b, PARAMS *my_params );

void set_partition_elem( PART_CELL *x, int ac, STAT freq, int n );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



void do_partition_model_w_info( INFO *my_info, PARAMS *my_params );

void do_partition_model_w_fh( INFO *my_info, PARAMS *my_params, FH_PART *my_fh );

void do_partition_model_single_generation( INFO *my_info, PARAMS *my_params,
  int t, FH_PART *my_fh );

void do_my_partition_model_single_generation( INFO *my_info, PARAMS *my_params );

void do_partition_model_single_generation_new_info( INFO *my_info, INFO *curr_info,
  PARAMS *my_params );

void do_partition_model_generation_boxes( INFO *my_info, INFO *curr_info,
  PARAMS *my_params );

void set_partition_model_boxes( INFO *my_info, INFO *curr_info );

void set_partition_model_boxes_single_part( PART *b_new, PART *b_old,
  STAT_CELL *w );

STAT get_y_denom_partition_model( PART *b, STAT_CELL *w );

void set_my_partition_model_boxes_single_part( PART *b_new, PART *b_old, 
  STAT_CELL *w, STAT denom );

STAT get_partition_model_single_hapl( PART *b, STAT_CELL *w, int x, STAT denom );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



void update_partition_box_freqs( INFO *my_info );

void copy_info_struct_w_part_cell( INFO *a, INFO *b );

void copy_part_cell( PART_CELL *a, PART_CELL *b );

















