


















#include "../ext/struct.h"











void do_partition_model_generation_tf( INFO *my_info, INFO *curr_info, 
  PARAMS *my_params );
  
void do_my_partition_model_generation_tf( INFO *my_info, INFO *curr_info,
  DISTR *my_distr, PARAMS *my_params );

void set_partition_model_fitnesses( INFO *my_info, INFO *curr_info,
  DISTR *my_distr, PARAMS *my_params );

void set_partition_model_distr( INFO *my_info, INFO *curr_info,
  DISTR *my_distr );

void set_my_partition_model_distr( INFO *my_info, INFO *curr_info,
  DISTR *my_distr );

void set_partition_model_single_distr( STAT_CELL *d, DISTR *my_distr, INFO *my_info,
  int nucl_array[], int nucl_not );

int set_binom_array_distr( STAT_CELL *z, PART *b, int nucl_array[], int nucl_not );

void init_stat_cell( STAT_CELL *z );

STAT get_prob_box_occur( PART *b, int nucl_array[] );

void set_binom_array_distr_up( STAT_CELL *z, PART *b, int mean, STAT pr,
  int nucl_not );

void set_binom_array_distr_down( STAT_CELL *z, PART *b, int mean, STAT pr,
  int nucl_not );

void set_binom_array_sum_distr( STAT_CELL *u, STAT_CELL *y, STAT_CELL *z,
  int y_n, int z_n, int mean );

void set_binom_array_sum_distr_up( STAT_CELL *u, STAT_CELL *y, STAT_CELL *z,
  int total, int mean );

void set_binom_array_sum_distr_down( STAT_CELL *u, STAT_CELL *y, STAT_CELL *z,
  int total, int mean );



/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/



void set_partition_fitness_w_distr( INFO *my_info, INFO *curr_info, 
  DISTR *my_distr, PARAMS *my_params );

void get_partition_relative_fitnesses( INFO *my_info, DISTR *my_distr,
  PARAMS *my_params );

STAT get_fitness_waa_partition( INFO *my_info, DISTR *my_distr, PARAMS *my_params );

STAT get_fitness_waa_partition_single_term( STAT_CELL *n_a, INFO *my_info,
  PARAMS *my_params, int i );

STAT get_fitness_wcc_partition( INFO *my_info, DISTR *my_distr, PARAMS *my_params );

STAT get_fitness_wcc_partition_single_term( STAT_CELL *n_c, INFO *my_info,
  PARAMS *my_params, int i );

STAT get_fitness_wac_partition( INFO *my_info, DISTR *my_distr, PARAMS *my_params );

STAT get_fitness_wac_partition_single_term( STAT_CELL *n_c, INFO *my_info,
  PARAMS *my_params, int i );

STAT get_new_p_freq_partition( DISTR *my_distr, INFO *my_info );























