

















#include "../ext/struct.h"








void do_evol_change( void );

void do_my_evol_change( MOL_LIST *mol, int aa_numb[], char aa_type[],
  int aa_subs[], char input_fname[] );
  
void do_evol_change_point_sub_mol_list( MOL_LIST *mol, int aa_numb[],
  char aa_type[], int aa_subs[] );

void do_evol_change_point_substitutions( MOL_LIST *mol, int aa_numb[],
  char aa_type[], int aa_subs[] );
  
void minimize_free_energy_evol_point_subs( MOL_LIST *mol );

void minimize_free_energy_single_angle_iteration( MOL_LIST *mol, 
  int changed_array[], STAT *angle );

void minimize_my_free_energy_single_angle_iteration( MOL_LIST *mol, 
  RESID_LIST *resid, RESID_LIST *end_resid, int changed_array[], STAT *angle );

void minimize_free_energy_single_angle_my_iter( MOL_LIST *mol, RESID_LIST *resid, 
  RESID_LIST *end_resid, int changed_array[], STAT *angle );

int arrays_are_same( int a[], int b[] );

void minimize_free_single_angle_single_resid_and_step( MOL_LIST *mol,
  RESID_LIST **resid, int curr_changed_array[], int *changed_numb, int index,
  STAT angle );

void minimize_free_single_angle_single_resid( MOL_LIST *mol, RESID_LIST *resid,
  int curr_changed_array[], int *changed_numb, int index, STAT angle );

void minimize_free_single_angle_aa_resid( MOL_LIST *mol, RESID_LIST *resid,
  int curr_changed_array[], int *changed_numb, int index, STAT angle );

void minimize_free_single_angle_ion_resid( MOL_LIST *mol, RESID_LIST *resid,
  int curr_changed_array[], int *changed_numb, int index, STAT angle );

void output_changed_mol( MOL_LIST *mol, MOL_LIST *init_mol, char input_fname[], 
  int aa_numb[], char aa_type[], int aa_subs[], int first_site, 
  int first_first_resid );

void get_output_fname_changed_mol( char output_fname[], char input_fname[],
  int aa_numb[], char aa_type[], int aa_subs[], int first_site, 
  int first_first_resid );

void output_my_changed_mol( MOL_LIST *mol, MOL_LIST *init_mol, FILE *out );
















