#include "stream.h"























FILE *open_text_file_reading( char a[], char b[] )
{

  FILE *fh = NULL;
  
  char fname[ BUFFER ];
  
  if ( b[ 0 ] == '\0' )
    strcpy( fname, a );
    
  else
    sprintf( fname, "%s.%s", a, b );
  
  fh = (FILE *)fopen( fname, "r" );
  
  if ( fh == NULL )
    error_file( 300, fname, "reading" );
    
  return fh;

}













FILE *open_text_file_writing( char a[], char b[] )
{

  FILE *fh = NULL;
  
  char fname[ BUFFER ];
  
  if ( b[ 0 ] == '\0' )
    strcpy( fname, a );
    
  else
    sprintf( fname, "%s.%s", a, b );
    
  fh = (FILE *)fopen( fname, "w" );
  
  if ( fh == NULL )
    error_file( 301, fname, "writing" );
    
  return fh;

}













void close_file( FILE *fh )
{
  if ( fclose( fh ) != 0 )
    error( 310, "Cannot close filehandle.\n" );
}















/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/













void error_file( int numb, char fname[], char type[] )
{

  char err[ BUFFER ];
  
  sprintf( err, "Cannot open file '%s' for %s\n", fname, type );
  
  error( numb, err );

}






