













#include "../ext/struct.h"













void get_matrix_inv( MATRIX *b, MATRIX *a );

void calc_inverse_matrix( MATRIX *b, MATRIX *a, MATRIX *vector, MATRIX *sol );

void compute_inv_column( MATRIX *b, MATRIX *a, MATRIX *vector, MATRIX *sol,
  int col );

void get_ident_vector_for_inv( MATRIX *vector, int col );

void put_column_into_matrix( MATRIX *b, MATRIX *sol, int col );

void system_of_eq( MATRIX *sol, MATRIX *vector, MATRIX *a );

void do_system_of_eq( MATRIX *sol, MATRIX *vector, MATRIX *a, MATRIX *l, 
  MATRIX *u );

void set_diag_l( MATRIX *l );

void do_lu_decomp( MATRIX *l, MATRIX *u, MATRIX *a );

void set_u_element( MATRIX *l, MATRIX *u, MATRIX *a, int i, int k );

STAT get_single_u_element_term( MATRIX *l, MATRIX *u, int i, int k, int kk );

void set_l_element( MATRIX *l, MATRIX *u, MATRIX *a, int i, int k );

STAT get_single_l_element_term( MATRIX *l, MATRIX *u, int i, int k, int kk );

void do_my_system_of_eq( MATRIX *sol, MATRIX *l, MATRIX *u, MATRIX *vector );

void do_system_of_eq_wyvec( MATRIX *sol, MATRIX *l, MATRIX *u, MATRIX *vector,
  MATRIX *y );

void find_y_system_of_eq( MATRIX *y, MATRIX *l, MATRIX *vector );

void find_sol_vector_system_of_eq( MATRIX *sol, MATRIX *u, MATRIX *y );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



void multiply_matrices( MATRIX *c, MATRIX *a, MATRIX *b );

void multiply_scalar_matrix( MATRIX *a, STAT x );

void copy_matrix( MATRIX *b, MATRIX *a );

STAT dot_prod_vector_matrices( MATRIX *a, MATRIX *b );

void add_matrices( MATRIX *c, MATRIX *a, MATRIX *b );

void print_matrix( MATRIX *mx );




















