#include "mm.h"
























void do_molecule( void )
{

  extern char minor_mode;

  if ( minor_mode == '\0' )
    error( 1000, "Minor mode not set for molecule run.\n" );

  switch ( minor_mode ) {
  
  case 'a' :
    /*  In mol.c:  */
    do_molecule_parsing();
    break;
    
  case 'r' :
    /*  In mol.c:  */
    do_struct_align();
    break;
    
  case 'R' :
    /*  In zf.c:  */
    do_zinc_finger_struct_align();
    break;
    
  default :
    error( 1001, "Unrecognized minor mode for molecule run.\n" );
    break;
  
  }

}






























