















#include "../ext/struct.h"













void do_molecule_parsing( void );



/*======================================================================*/
/*======================================================================*/
/*======================================================================*/



void do_struct_align( void );

MOL_LIST *get_aligned_struct_w_mol_lists( MOL_LIST *new_mol, MOL_LIST *mol_header,
  MOL_LIST *minor_header, char major_substr[], char minor_substr[], char major_mol,
  char minor_mol );

MOL_LIST *get_my_aligned_struct_w_mol_lists( MOL_LIST *new_mol, MOL_LIST *mol_header, 
  MOL_LIST *minor_header, char major_substr[], char minor_substr[], char major_mol,
  char minor_mol );

MOL_LIST *get_aligned_struct_w_cells( MOL_LIST *new_mol, MOL_LIST *mol_header, 
  MOL_LIST *minor_header, XYZ_CELL *major_cell, XYZ_CELL *minor_cell, 
  char major_substr[], char minor_substr[], char major_mol, char minor_mol );



/*======================================================================*/
/*======================================================================*/
/*======================================================================*/



MOL_LIST *get_new_mol_from_rotation_struct( MOL_LIST *new_mol, MOL_LIST *mol_header,
  ROT_PARAMS *my_param );

MOL_LIST *rotate_single_mol_lister_and_step( MOL_LIST *new_mol, MOL_LIST **mol,
  ROT_PARAMS *my_param );

MOL_LIST *rotate_single_mol_lister( MOL_LIST *new_mol, MOL_LIST *mol,
  ROT_PARAMS *my_param );

MOL_LIST *put_mol_lister_end_of_list( MOL_LIST *mol_header, MOL_LIST *mol );

RESID_LIST *rotate_resid_list( RESID_LIST *new_header, RESID_LIST *resid_header,
  ROT_PARAMS *my_param );

RESID_LIST *rotate_single_resid_lister_and_step( RESID_LIST *new_header,
  RESID_LIST **resid, ROT_PARAMS *my_param );

RESID_LIST *rotate_single_resid_lister( RESID_LIST *new_header, RESID_LIST *resid,
  ROT_PARAMS *my_param );

RESID_LIST *put_resid_lister_end_of_list( RESID_LIST *header, RESID_LIST *x );

ATOM_LIST *rotate_atom_list( ATOM_LIST *new_header, ATOM_LIST *atom_header,
  ROT_PARAMS *my_param );

ATOM_LIST *rotate_single_atom_lister_and_step( ATOM_LIST *new_header,
  ATOM_LIST **atom, ROT_PARAMS *my_param );

ATOM_LIST *rotate_single_atom_lister( ATOM_LIST *new_header, ATOM_LIST *atom,
  ROT_PARAMS *my_param );

ATOM_LIST *put_atom_lister_end_of_list( ATOM_LIST *new_header, ATOM_LIST *x );

void rotate_my_single_atom_lister( ATOM_LIST *x, ATOM_LIST *atom, 
  ROT_PARAMS *my_param );

void rotate_xyz_rot_params( XYZ *a, XYZ *b, ROT_PARAMS *my_param );

STAT get_xyz_rot_param_single_coord( XYZ *xyz, ROT_PARAMS *pp, char c );



/*======================================================================*/
/*======================================================================*/
/*======================================================================*/



MOL_LIST *copy_mol_lister_w_label_char( MOL_LIST *major, MOL_LIST *minor_header, 
  char label_char );

MOL_LIST *get_mol_lister_from_list_label_char( MOL_LIST *header, char label_char );

MOL_LIST *copy_mol_lister( MOL_LIST *major, MOL_LIST *minor );

RESID_LIST *copy_resid_list( RESID_LIST *major_header, RESID_LIST *minor_header );

RESID_LIST *make_and_put_resid_lister_and_step( RESID_LIST *major_header,
  RESID_LIST **resid );

RESID_LIST *make_and_put_resid_lister( RESID_LIST *major_header, RESID_LIST *resid );

RESID_LIST *copy_resid_lister( RESID_LIST *new_resid, RESID_LIST *resid );

ATOM_LIST *copy_atom_list( ATOM_LIST *major_header, ATOM_LIST *atom_header );

ATOM_LIST *make_and_put_atom_lister_and_step( ATOM_LIST *major_header,
  ATOM_LIST **atom );

ATOM_LIST *make_and_put_atom_lister( ATOM_LIST *major_header, ATOM_LIST *atom );

MOL_LIST *copy_neigh_and_connect_lists( MOL_LIST *major, MOL_LIST *minor );

void copy_connect_list( MOL_LIST *major, MOL_LIST *minor );

void copy_connect_list_single_resid_lister_and_step( RESID_LIST **major_resid,
  RESID_LIST **minor_resid, MOL_LIST *major_mol, MOL_LIST *minor_mol );

void copy_connect_list_single_resid_lister( RESID_LIST *major_resid,
  RESID_LIST *minor_resid, MOL_LIST *major_mol, MOL_LIST *minor_mol );

void copy_connect_list_single_atom_lister_and_step( ATOM_LIST **major_atom,
  ATOM_LIST **minor_atom, MOL_LIST *major_mol, MOL_LIST *minor_mol );

void copy_connect_list_single_atom_lister( ATOM_LIST *major_atom,
  ATOM_LIST *minor_atom, MOL_LIST *major_mol, MOL_LIST *minor_mol );

void copy_connect_list_single_connect_lister_and_step( ATOM_LIST *major_atom,
  ATOM_LIST **con_atom, MOL_LIST *major_mol, MOL_LIST *minor_mol );

void copy_connect_list_single_connect_lister( ATOM_LIST *major_atom,
  ATOM_LIST *con_atom, MOL_LIST *major_mol, MOL_LIST *minor_mol );

ATOM_LIST *get_atom_in_mol_list_w_numb( MOL_LIST *mol, int numb );

















