














#include "../ext/struct.h"











void rotate_mol( ROT_PARAMS *my_param, XYZ_CELL *major_cell, XYZ_CELL *minor_cell );

void get_and_set_centered_cells( ROT_PARAMS *my_param, XYZ_CELL *major_cell,
  XYZ_CELL *minor_cell );

void get_centered_xyz_coords( STAT trans[], XYZ_CELL *my_cell );

STAT get_expected_val_coord_index( XYZ_CELL *my_cell, char index );

STAT get_val_xyz_coord_index( XYZ *x, char index );

void set_centered_xyz_coords( XYZ_CELL *my_cell, STAT trans[] );

void center_single_xyz_coord_trans_array( XYZ *x, STAT trans[] );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



void rotate_my_mol( ROT_PARAMS *my_param, XYZ_CELL *major_cell, 
  XYZ_CELL *minor_cell );

void rotate_mol_w_matrices( ROT_PARAMS *my_param, MX_STRUCT *my_mx, 
  XYZ_CELL *major_cell, XYZ_CELL *minor_cell );

void set_rot_params_from_matrix( ROT_PARAMS *my_param, MATRIX *mx );

void rotate_mol_matrix_guess( MX_STRUCT *my_mx, XYZ_CELL *major_cell,
  XYZ_CELL *minor_cell );

void rotate_mol_single_initial_params( MX_STRUCT *my_mx, XYZ_CELL *major_cell, 
  XYZ_CELL *minor_cell, STAT theta_x, STAT theta_y, STAT theta_z );

void set_initial_mx_theta_vals( MATRIX *mx, STAT theta_x, STAT theta_y,
  STAT theta_z );

STAT rotate_my_mol_single_initial_params( MX_STRUCT *my_mx, XYZ_CELL *major_cell, 
  XYZ_CELL *minor_cell );

int rotate_mol_single_iteration( MX_STRUCT *my_mx, XYZ_CELL *major_cell,
  XYZ_CELL *minor_cell, STAT *sum_of_squares );

STAT rotate_my_mol_single_iteration( MX_STRUCT *my_mx, XYZ_CELL *major_cell,
  XYZ_CELL *minor_cell );

int set_new_params_rotation_iteration( MX_STRUCT *my_mx, STAT new_ss, 
  STAT *sum_of_squares );

int non_number_mx_struct( MX_STRUCT *my_mx );

int non_number_mx( MATRIX *mx );

int iteration_has_converged( MX_STRUCT *my_mx, STAT new_ss, STAT sum_of_squares );

void set_my_new_params_rotation_iteration( MX_STRUCT *my_mx );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



STAT rotate_mol_matrix_final( MX_STRUCT *my_mx, XYZ_CELL *major_cell, 
  XYZ_CELL *minor_cell );

STAT rotate_my_mol_matrix_final( MX_STRUCT *my_mx, XYZ_CELL *major_cell,
  XYZ_CELL *minor_cell );

int rotate_mol_final_single_iteration( MX_STRUCT *my_mx, XYZ_CELL *major_cell,
  XYZ_CELL *minor_cell, STAT *sum_of_squares );

STAT rotate_my_mol_final_single_iteration( MX_STRUCT *my_mx, XYZ_CELL *major_cell,
  XYZ_CELL *minor_cell );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



STAT get_sum_of_squares_mx_and_cell( MX_STRUCT *my_mx, XYZ_CELL *major_cell,
  XYZ_CELL *minor_cell );

STAT get_sum_of_squares_matrix( MATRIX *mx, XYZ_CELL *major_cell, 
  XYZ_CELL *minor_cell );

STAT get_squares_xyz_coord_and_mx( MATRIX *p, XYZ *major_coord, XYZ *minor_coord );

STAT get_sum_squares_param_mx( MATRIX *p, XYZ_CELL *major_cell, 
  XYZ_CELL *minor_cell );

STAT get_sum_of_squares_mx_and_cell_euclidean( MX_STRUCT *my_mx, 
  XYZ_CELL *major_cell, XYZ_CELL *minor_cell );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



STAT rotate( XYZ *point, MATRIX *p, char index );

STAT rotate_x( XYZ *point, MATRIX *p );

STAT rotate_y( XYZ *point, MATRIX *p );

STAT rotate_z( XYZ *point, MATRIX *p );





























