














#include "../ext/struct.h"
#include "ext.h"












typedef struct fh_struct {
  FILE *out;
  FILE *gene;
  FILE *in;
} FH;










void do_change_ft( void );

void do_my_change_ft( void );

void do_change_ft_w_node_tree( NODE_LIST *node_header );

void set_change_ft_fh( FH *my_fh );

void close_change_ft_fh( FH *my_fh );

void do_my_change_ft_w_node_tree( NODE_LIST *node_header, FH *my_fh );

void do_change_ft_w_leaf_list( NODE_LIST *leaf_header, FH *my_fh );

void put_change_ft_file_header_line( NODE_LIST *leaf_header, FH *my_fh );

void do_my_change_ft_w_leaf_list( NODE_LIST *leaf_header, FH *my_fh );

FPOS_CELL *make_fpos_cell_for_change_ft_leaf_header( FPOS_CELL *fpos_cell,
  NODE_LIST *leaf_header );

INDEX get_numb_of_leaves( NODE_LIST *leaf_header );

void do_change_ft_w_fpos_cell( NODE_LIST *leaf_header, FPOS_CELL *fpos_cell, 
  FH *my_fh );

int change_ft_input_still_going( NODE_LIST *leaf, FPOS_CELL *fpos_cell );

FILE *get_species_column_fh( char spec[] );

void do_change_ft_single_gene( NODE_LIST *leaf_header, FPOS_CELL *fpos_cell, 
  SEQ seq, FH *my_fh );

void do_change_ft_single_gene_single_leaf_and_step( NODE_LIST **leaf, 
  FPOS_CELL *fpos_cell, SEQ seq, INDEX spec_index, FH *my_fh );

void do_change_ft_single_gene_single_leaf( NODE_LIST *leaf, FPOS_CELL *fpos_cell,
  SEQ seq, INDEX spec_index, FH *my_fh );

void do_change_ft_single_gene_single_leaf_w_fh( NODE_LIST *leaf, SEQ seq, 
  INDEX spec_index, FH *my_fh );

void do_change_ft_single_gene_single_leaf_w_line( char line[], SEQ seq,
  INDEX spec_index, FH *my_fh );

void do_change_ft_single_gene_initial_info( char line[], SEQ seq, FH *my_fh );

void do_my_change_ft_single_gene_initial_info( char acc[], SEQ seq, FH *my_fh );

void get_gene_name_gene_acc_fh( char gene[], char acc[], FILE *fh );

void do_my_change_ft_single_gene_single_leaf_w_line( char line[], SEQ seq, 
  INDEX spec_index, FH *my_fh );









