












#include "../ext/struct.h"













void do_single_spec_comparison( void );

void get_species_occur_fname_base( char fname[], char spec[] );

void do_single_spec_comparison_w_fnames( char gene_fname[], char major_file[], 
  char minor_file[] );

void do_single_spec_comparison_single_site( MOTIF *mf, char gene_fname[],
  char major_file[], char minor_file[], char site );

void do_my_single_spec_comparison_single_site( MOTIF *mf, char gene_fname[],
  char major_file[], char minor_file[], char site );

void do_single_species_comparison_w_occur_lists( GENE_LIST *major_header,
  GENE_LIST *minor_header, MOTIF *mf, char gene_fname[], char major_file[],
  char minor_file[], char site );



/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/



void do_comprehensive_spec_comparisons( void );

void do_comprehensive_spec_comparisons_major_fname( char major_fname[] );

void do_compr_spec_comp_minor_species_list( STR_LIST *spec_header, 
  char major_fname[] );

GENE_LIST *get_single_gene_list( GENE_LIST *gene_header, MOTIF *mf, char site,
  char fname[] );

GENE_LIST *get_my_single_gene_list( GENE_LIST *gene_header, MOTIF *mf,
  char site, char fname[] );

void do_compr_spec_comp_major_gene_list( GENE_LIST *major_gene_header[], 
  STR_LIST *spec_header, MOTIF *mf );

void do_compr_spec_comp_single_spec_pair_and_step( GENE_LIST *major_gene_header[],
  STR_LIST **spec, MOTIF *mf, int numb );

void do_compr_spec_comp_single_spec_pair( GENE_LIST *major_gene_header[],
  STR_LIST *spec, MOTIF *mf, int numb );

void do_my_compr_spec_comp_single_spec_pair( GENE_LIST *major_gene_header[], 
  char major_spec[], char minor_spec[], MOTIF *mf, char minor_fname[],
  char out_fname[], int numb );

void do_compr_spec_comp_single_pair_out_fh( GENE_LIST *major_gene_header[],
  char major_spec[], char minor_spec[], MOTIF *mf, int numb, char minor_fname[], 
  FILE *out );

void do_compr_spec_comp_single_pair_single_site( GENE_LIST *major_header,
  char major_spec[], char minor_spec[], MOTIF *mf, char site, int numb,
  char minor_fname[], FILE *out );

void do_compr_spec_single_spec_pair_two_gene_lists( GENE_LIST *major_header, 
  GENE_LIST *minor_header, char major_spec[], char minor_spec[], MOTIF *mf, 
  char site, FILE *out );



/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/



void do_forward_reverse_spec_comparison( void );

void do_forward_reverse_spec_comp_fnames( char major_file[], char minor_file[],
  char gene_fname[], char major_spec[], char minor_spec[] );

void do_forward_reverse_spec_comp_single_site( char major_file[], 
  char minor_file[], char major_spec[], char minor_spec[], char gene_fname[],
  MOTIF *mf, char site );

void do_single_species_comp_forward_and_rev_occur_lists( GENE_LIST *major_header, 
  GENE_LIST *minor_header, MOTIF *mf, char gene_fname[], char major_file[], 
  char minor_file[], char major_spec[], char minor_spec[], char site );



/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/



void do_forward_rev_comprehensive_spec_comp( void );

void do_forward_rev_comprehensive_spec_comp_w_fname( char major_file[] );

void do_forward_rev_compr_spec_comp_w_spec_list( STR_LIST *spec_header,
  char major_file[] );

GENE_LIST *get_single_gene_list_forward_rev( GENE_LIST *gene_header, MOTIF *mf,
  char site, char major_fname[] );

GENE_LIST *get_my_single_gene_list_forward_rev( GENE_LIST *gene_header,
  MOTIF *mf, char site, char major_fname[] );

void do_compr_spec_comp_forward_rev_major_gene_list( GENE_LIST *major_gene_header[], 
  STR_LIST *spec_header, MOTIF *mf, char major_spec[], char major_fname[] );

void do_compr_single_spec_comp_forward_rev_and_step( GENE_LIST *major_gene_header[],
  STR_LIST **spec, MOTIF *mf, char major_spec[], char major_fname[], int numb );

void do_compr_single_spec_comp_forward_rev( GENE_LIST *major_gene_header[],
  STR_LIST *spec, MOTIF *mf, char major_spec[], char major_fname[], int numb );

void do_my_compr_single_spec_comp_forward_rev( GENE_LIST *major_gene_header[],
  MOTIF *mf, char major_spec[], char minor_spec[], char major_fname[], int numb );

void do_my_compr_spec_comp_single_spec_pair_forward_rev( GENE_LIST *major_header[],
  char major_spec[], char minor_spec[], MOTIF *mf, char major_fname[],
  char minor_fname[], char out_fname[], int numb );

void do_compr_spec_comp_single_pair_forward_rev_out_fh( GENE_LIST *major_header[],
  char major_spec[], char minor_spec[], MOTIF *mf, int numb, char major_fname[],
  char minor_fname[], FILE *out );

void do_compr_spec_comp_forward_rev_single_site( GENE_LIST *major_header,
  char major_spec[], char minor_spec[], MOTIF *mf, int numb, char site,
  char major_fname[], char minor_fname[], FILE *out );

void do_single_species_comp_forward_and_rev_lists_fh( GENE_LIST *major_header, 
  GENE_LIST *minor_header, MOTIF *mf, char gene_fname[], char major_fname[], 
  char minor_fname[], char major_spec[], char minor_spec[], char site, FILE *out );



/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/



void get_species_occur_fname_base( char fname[], char spec[] );

void get_species_compare_out_fname( char out_fname[], char major_spec[], MOTIF *mf, 
  char minor_spec[] );













