

















#include "../ext/struct.h"









GENE_LIST *get_gene_occur_list_fname( GENE_LIST *gene_header, MOTIF *motif,
  char gene_fname[], char fname[] );

GENE_LIST *get_gene_occur_list_fh( GENE_LIST *gene_header, MOTIF *mf, FILE *bin_fh,
  FILE *ind_fh, FILE *gene_fh );

GENE_LIST *get_gene_occur_list_fh( GENE_LIST *gene_header, MOTIF *motif, 
  FILE *bin_fh, FILE *ind_fh, FILE *gene_fh );

GENE_LIST *get_gene_occur_list_single_mf( GENE_LIST *gene_header, MOTIF *motif, 
  MF mf, FILE *bin_fh, FILE *ind_fh, FILE *gene_fh );

GENE_LIST *get_gene_occur_list_single_matching_mf( GENE_LIST *gene_header,
  MOTIF *motif, MF mf, FILE *bin_fh, FILE *ind_fh, FILE *gene_fh );



/*========================================================================*/
/*========================================================================*/
/*========================================================================*/



GENE_LIST *get_my_gene_occur_list_single_matching_mf( GENE_LIST *gene_header,
  MOTIF *motif, MF mf, FILE *bin_fh, FILE *ind_fh, FILE *gene_fh );

GENE_LIST *get_gene_occur_list_w_occur_ind_struct( GENE_LIST *gene_header,
  MOTIF *motif, MF mf, OCCUR_IND *my_ind, FILE *bin_fh, FILE *gene_fh );

GENE_LIST *get_gene_occur_list_single_occur( GENE_LIST *gene_header, 
  MOTIF *motif, FILE *bin_fh, FILE *gene_fh );

GENE_LIST *get_and_put_new_occurrence_gene_list( GENE_LIST *gene_header,
  OCCUR *my_occur, MOTIF *motif, FILE *gene_fh );

OCR_LIST *get_new_occurrence_gene_list( OCR_LIST *ocr, OCCUR *my_occur,
  MOTIF *motif );

GENE_LIST *merge_new_occurrence_gene_list( GENE_LIST *gene_header, 
  OCR_LIST *ocr, OCCUR *my_occur, FILE *gene_fh );

GENE_LIST *merge_new_occurrence_gene_list_new_seq( GENE_LIST *gene_header,
  OCR_LIST *ocr, OCCUR *my_occur, FILE *gene_fh );

GENE_LIST *get_new_occurrence_gene_lister( GENE_LIST *gene, OCCUR *my_occur,
  FILE *gene_fh );

GENE_LIST *merge_my_new_occurrence_gene_list( GENE_LIST *gene_header, 
  OCR_LIST *ocr, OCCUR *my_occur, FILE *gene_fh );

GENE_LIST *add_new_occurrence_new_seq_at_beginning( GENE_LIST *gene_header,
  OCR_LIST *ocr, OCCUR *my_occur, FILE *gene_fh );

GENE_LIST *merge_new_occurrence_gene_list_middle( GENE_LIST *gene_header, 
  OCR_LIST *ocr, OCCUR *my_occur, FILE *gene_fh );

GENE_LIST *merge_new_occurrence_at_gene_list_end( GENE_LIST *gene_header,
  OCR_LIST *ocr, OCCUR *my_occur, GENE_LIST *prev, FILE *gene_fh );

GENE_LIST *merge_new_occurrence_at_my_gene_list_end( GENE_LIST *gene_header, 
  OCR_LIST *ocr, OCCUR *my_occur, GENE_LIST *curr, FILE *gene_fh );

GENE_LIST *merge_new_occurrences_existing_seq( GENE_LIST *gene_header, 
  OCR_LIST *ocr, OCCUR *my_occur, GENE_LIST *curr );



/*========================================================================*/
/*========================================================================*/
/*========================================================================*/



GENE_LIST *get_gene_for_rev_occur_list_fname( GENE_LIST *major_header, MOTIF *mf, 
  char gene_fname[], char fname[] );

GENE_LIST *get_for_rev_gene_occur_list_fh( GENE_LIST *gene_header, MOTIF *motif,
  FILE *bin_fh, FILE *ind_fh, FILE *gene_fh );

GENE_LIST *get_for_rev_gene_occur_list_single_mf( GENE_LIST *gene_header,
  MOTIF *motif, MF mf, FILE *bin_fh, FILE *ind_fh, FILE *gene_fh );

char get_strand_for_forward_rev_gene_occur_list( MOTIF *motif, MF mf );

GENE_LIST *get_forward_rev_gene_occur_list_w_motif( GENE_LIST *gene_header,
  MOTIF *motif, char strand, FILE *bin_fh, FILE *ind_fh, FILE *gene_fh );

GENE_LIST *get_forward_rev_gene_occur_list_w_ind_struct( GENE_LIST *gene_header,
  MOTIF *motif, char strand, OCCUR_IND *my_ind, FILE *bin_fh, FILE *gene_fh );

GENE_LIST *get_forward_rev_single_motif_occur( GENE_LIST *gene_header,
  MOTIF *motif, char strand, FILE *bin_fh, FILE *gene_fh );

GENE_LIST *get_and_put_new_forward_rev_occurrence_gene_list( GENE_LIST *gene_header, 
  OCCUR *my_occur, MOTIF *motif, char strand, FILE *gene_fh );












