



















#include "../ext/struct.h"










void print_co_occur_matrix_list( MATRIX_LIST *mx_header, MOTIF *mf, char site, 
  char major_spec[], char minor_spec[], FILE *fh );

void print_co_occur_matrix_lister( MATRIX_LIST *mx, MOTIF *mf, char site,
  char major_spec[], char minor_spec[], FILE *fh );

void print_co_occur_matrix( MATRIX *mx, MOTIF *mf, char site, char major_spec[], 
  char minor_spec[], FILE *fh );

void print_degenerate_mf( MOTIF *mf, char site, FILE *fh );

void print_my_co_occur_matrix( MATRIX *mx, MOTIF *mf, char site, char major_spec[],
  char minor_spec[], FILE *fh );

void print_co_occur_matrix_first_lines( MOTIF *mf, char site, char spec[], 
  FILE *fh );

void print_co_occur_matrix_co_occur_elems( MATRIX *mx, FILE *fh );

void print_co_occur_matrix_single_line_co_occur_elems( MATRIX *mx, char i,
  FILE *fh );

void print_frac_matrix( MATRIX *mx, MOTIF *mf, char site, char major_spec[], 
  char minor_spec[], FILE *fh );

void print_rest_of_frac_matrix( MATRIX *mx, MOTIF *mf, char site, 
  char major_spec[], char minor_spec[], FILE *fh );

void print_frac_matrix_single_line_co_occur_elems( MATRIX *mx, char i,
  FILE *fh );



/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/



void print_nucl_freqs_matrix_lister( MATRIX_LIST *mx, char major_spec[], 
  char minor_spec[], FILE *fh );

void print_nucl_freqs_matrix( MATRIX *mx, char major_spec[], char minor_spec[],
  FILE *fh );

void print_nucl_freqs_major_spec( MATRIX *mx, char major_spec[], FILE *fh );

void print_my_nucl_freqs_major_spec( MATRIX *mx, FILE *fh );

void print_nucl_freqs_major_spec_single_nucl( MATRIX *mx, int i, FILE *fh );

COUNT get_total_count_nucl_freqs_row( MATRIX *mx, int i );

STAT get_total_freq_nucl_freqs_row( MATRIX *mx, int i );

void print_nucl_freqs_minor_spec( MATRIX *mx, char minor_spec[], FILE *fh );

void print_my_nucl_freqs_minor_spec( MATRIX *mx, FILE *fh );

void print_nucl_freqs_minor_spec_single_nucl( MATRIX *mx, char i, FILE *fh );

COUNT get_total_count_nucl_freqs_column( MATRIX *mx, char j );

STAT get_total_freq_nucl_freqs_column( MATRIX *mx, char j );



/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/



void pr_blank( FILE *fh, int length );
























