
















#include "../ext/struct.h"












void do_mammal_evol( void );

void do_mammal_evol_w_tree( ND_LIST *root, ND_LIST *leaf_header );

PARAM *make_and_initialize_mammal_params( PARAM *param );

void do_mammal_evol_w_params( ND_LIST *root, ND_LIST *leaf_header, PARAM *param );

void do_my_mammal_evol_w_params( ND_LIST *root, ND_LIST *leaf_header,
  PARAM *param, FILE *out );

int do_mammal_evol_params_single_iter( ND_LIST *root, ND_LIST *leaf_header,
  PARAM *param, INDEX iter, FILE *out );

int do_mammal_evol_params_single_iter_w_fh( ND_LIST *root, ND_LIST *leaf_header,
  PARAM *param, INDEX iter, FILE *in, FILE *out );

void set_prior_probs_for_mammals( ND_LIST *root, ND_LIST *leaf_header, FILE *in );

int do_my_mammal_evol_params_single_iter_w_fh( ND_LIST *root, ND_LIST *leaf_header, 
  PARAM *param, INDEX iter, FILE *in, FILE *out );

void set_mammal_param_types( ND_LIST *root );

void set_param_types_descendent_nodes( ND_LIST *node, char param_type );

int do_mammal_evol_set_param_types( ND_LIST *root, ND_LIST *leaf_header, 
  PARAM *param, INDEX iter, FILE *in, FILE *out );

PARAM *make_and_copy_params( PARAM *new, PARAM *old );

void copy_params( PARAM *a, PARAM *b );

void get_new_params_mammal_evol( PARAM *param, ND_LIST *root, ND_LIST *leaf_header, 
  INDEX iter, FILE *in, FILE *out );



/*========================================================================*/
/*========================================================================*/
/*========================================================================*/



void put_trans_probs_into_tree_varying_params( ND_LIST *node, PARAM *param );

void put_my_trans_probs_into_tree_varying_params( ND_LIST *node, PARAM *param );



/*========================================================================*/
/*========================================================================*/
/*========================================================================*/



void get_params_mammal_evol_w_trans_probs( PARAM *param, ND_LIST *root, 
  ND_LIST *leaf_header, INDEX iter, FILE *in, FILE *out );

void get_params_mammal_evol_w_label_list( PARAM *param, ND_LIST *root, 
  ND_LIST *leaf_header, STR_LIST *label_header, INDEX iter, FILE *in, FILE *out );

void get_params_mammal_evol_single_gene( ND_LIST *root, ND_LIST *leaf_header,
  STR_LIST *label_header, SEQ seq_numb, INDEX iter, char line[] );

void get_params_mammal_evol_single_gene_filled_nodes( ND_LIST *ancestor );



/*========================================================================*/
/*========================================================================*/
/*========================================================================*/



void get_params_mammal_evol_w_info( PARAM *param, ND_LIST *root, 
  ND_LIST *leaf_header, INDEX iter, FILE *out );



















