












#include "../ext/struct.h"








typedef struct fh_struct {
  FILE *in;
  FILE *bird_out;
  FILE *euth_out;
  FILE *mam_out;
} FH;







void do_lineage_max( void );

void initialize_lineage_max( FH *my_fh );

void close_lineage_max( FH *my_fh );

void do_my_lineage_max( FH *my_fh );

void do_lineage_max_w_tree( ND_LIST *root, ND_LIST *leaf_header, FH *my_fh );

void do_my_lineage_max_w_tree( ND_LIST *root, ND_LIST *leaf_header, 
  STR_LIST *label_header, FH *my_fh );

void get_lineage_max_single_gene( ND_LIST *root, ND_LIST *leaf_header,
  STR_LIST *label_header, char line[], FH *my_fh );

void get_lineage_max_single_gene_set_tree( ND_LIST *root, int numb, char gene[],
  char acc[], FH *my_fh );

void get_and_put_lineage_max_single_node( ND_LIST *node, int numb, char gene[],
  char acc[], FILE *out );

int get_max_downstream_nodes( ND_LIST *node, int x );

int get_single_downstream_node_count( ND_LIST *node );

















