













#include "../ext/struct.h"









void do_alignment_extraction( void );

void do_my_alignment_extraction( FILE *in, FILE *info, FILE *out );

STR_LIST *get_spec_maf_alignment_list( STR_LIST *spec_header, FILE *in );

STR_LIST *get_spec_list_maf_single_line( STR_LIST *spec_header, char line[] );

STR_LIST *get_spec_list_maf_single_align_line( STR_LIST *spec_header, char line[] );

void get_species_name_maf( char spec[], char line[] );

STR_LIST *get_spec_list_maf_single_spec_string( STR_LIST *spec_header, char spec[] );

int str_in_str_list( char str[], STR_LIST *str_header );

STR_LIST *get_spec_list_maf_new_spec_lister( STR_LIST *spec_header, char spec[] );

STR_LIST *put_spec_lister_end_of_list( STR_LIST *spec_header, STR_LIST *new );



/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/



void do_alignment_extraction_w_spec_list( STR_LIST *spec_header, FILE *in, 
  FILE *info, FILE *out );

void do_alignment_extract_single_entry( char line[], STR_LIST *spec_header,
  FPOS *fpos, FILE *in, FILE *out );

void do_alignment_extract_single_entry_major_spec_info( GENCOORD_ENTRY *gene_entry,
  STR_LIST *spec_header, FPOS *fpos, FILE *in, FILE *out );

MAF_LIST *get_alignment_maf_list_single_gene( MAF_LIST *maf_header,
  GENCOORD_ENTRY *gene_entry, STR_LIST *spec_header, FPOS *fpos, FILE *in );

MAF_LIST *make_and_set_maf_list_all_spec( MAF_LIST *maf_header,
  STR_LIST *spec_header );

MAF_LIST *make_and_set_single_maf_spec_and_step( MAF_LIST *maf_header,
  STR_LIST **spec );

MAF_LIST *make_and_set_single_maf_spec( MAF_LIST *maf_header, STR_LIST *spec );

MAF_LIST *put_single_maf_spec_into_list( MAF_LIST *maf_header, MAF_LIST *maf );

MAF_LIST *get_alignment_maf_first_lines( MAF_LIST *maf_header, 
  GENCOORD_ENTRY *gene_entry, STR_LIST *spec_header, FPOS *fpos, FILE *in );

MAF_LIST *get_alignment_maf_first_single_line( MAF_LIST *maf_header, char line[],
  GENCOORD_ENTRY *gene_entry, STR_LIST *spec_header, FPOS *fpos, 
  int *after_found, FILE *in );

int gene_gencoord_matches_maf_gencoord( GENCOORD_ENTRY *gene_entry, 
  GENCOORD_ENTRY *maf_entry );

MAF_LIST *make_maf_alignment_original_list( MAF_LIST *maf_header,
  STR_LIST *spec_header );

MAF_LIST *make_maf_align_list_single_spec_and_step( MAF_LIST *maf_header,
  STR_LIST **spec );

MAF_LIST *make_maf_align_list_single_spec( MAF_LIST *maf_header, STR_LIST *spec );

MAF_LIST *put_maf_align_lister_into_list( MAF_LIST *maf_header, MAF_LIST *maf );

MAF_LIST *get_alignment_maf_first_single_matching_line( MAF_LIST *maf_header,
  char line[], GENCOORD_ENTRY *maf_entry, GENCOORD_ENTRY *gene_entry,
  STR_LIST *spec_header, int *after_found, FILE *in );

MAF_LIST *get_alignment_maf_matching_entries( MAF_LIST *maf_header, char line[],
  GENCOORD_ENTRY *maf_entry, GENCOORD_ENTRY *gene_entry, STR_LIST *spec_header,
  int *after_found, FILE *in );

MAF_LIST *get_alignment_maf_single_matching_line( MAF_LIST *maf_header,
  char my_line[], char line[], GENCOORD_ENTRY *maf_entry, 
  GENCOORD_ENTRY *gene_entry, STR_LIST *spec_header, int *after_found, 
  int *still_going );

MAF_LIST *make_and_put_new_maf_listers_new_entry( MAF_LIST *maf_header );

MAF_LIST *make_and_put_new_maf_new_entry_and_step( MAF_LIST *maf_header,
  MAF_LIST **maf );

MAF_LIST *make_and_put_new_maf_new_entry( MAF_LIST *maf_header, MAF_LIST *maf );

MAF_LIST *put_new_maf_new_entry( MAF_LIST *maf_header, MAF_LIST *maf,
  MAF_LIST *new );

MAF_LIST *set_new_maf_lister_maf_gencoord_line( MAF_LIST *maf_header, 
  GENCOORD_ENTRY *entry, char maf_line[] );

MAF_LIST *get_correct_maf_lister_spec_name( MAF_LIST *maf_header,
  GENCOORD_ENTRY *entry );




















