











#include "../ext/struct.h"










void do_fasta_to_gencoord_files( void );

void do_my_fasta_to_gencoord_files( char input_fname[], char output_fname[] );

void do_fasta_to_gencoord_files_input_fh( FILE *in, char output_fname[] );

int check_non_empty_file( FILE *in );

int do_fasta_to_gencoord_single_output_file( int *gene_numb, char output_fname[],
  FILE *in );

int do_my_fasta_to_gencoord_single_output_file( int *gene_numb, FILE *in,
  FILE *out );

void get_and_put_gencoord_file_entry( FILE *in, FILE *out );



/*========================================================================*/
/*========================================================================*/
/*========================================================================*/



void get_gencoord_entry_fasta_label( GENCOORD_ENTRY *entry, char line[] );

void set_gencoord_entry_spec_from_fasta_label( GENCOORD_ENTRY *entry,
  char line[] );

void set_gencoord_entry_gene_from_fasta_label( GENCOORD_ENTRY *entry, char line[] );

void get_line_after_underscores( char my_line[], char line[], int count );

void set_my_gencoord_entry_gene_from_fasta_label( GENCOORD_ENTRY *entry, 
  char line[] );

void set_gencoord_entry_chr_from_fasta_label( GENCOORD_ENTRY *entry, char line[] );

void set_gencoord_entry_start_and_end_from_fasta_label( GENCOORD_ENTRY *entry, 
  char line[] );

void set_gencoord_entry_strand_from_fasta_label( GENCOORD_ENTRY *entry, 
  char line[] );

void set_gencoord_entry_info( GENCOORD_ENTRY *entry );

void get_gencoord_entry_from_line( GENCOORD_ENTRY *entry, char line[] );

void get_my_gencoord_entry_from_line( GENCOORD_ENTRY *entry, char str[] );

void get_string_from_dot_numb( char entry[], char str[], int numb );


/*========================================================================*/
/*========================================================================*/
/*========================================================================*/



void do_maf_alignment_condensing( void );

void do_my_maf_alignment_condensing( char input_fname[], char info_fname[],
  char out_fname[], char info_out[] );

void do_maf_alignment_condensing_w_output_fh( char input_fname[], 
  char info_fname[], FILE *info_out_fh, FILE *out );

void do_maf_alignment_condensing_single_fname( char fname[], char info_fname[],
  int file_numb, FILE *info_out_fh, FILE *out );

void do_maf_alignment_condensing_single_fh( FILE *in, FILE *info_fh, 
  FILE *info_out_fh, FILE *out );

void do_maf_alignment_condensing_single_line( char line[], FILE *out );



/*========================================================================*/
/*========================================================================*/
/*========================================================================*/



void set_fasta_to_gencoord_files_fnames( char input_fname[], char output_fname[] );

void get_fasta_to_gencoord_output_fname( char fname[], char output_fname[],
  int gene_numb );

/*========================================================================*/

void set_maf_alignment_condensing_fnames( char in_fname[], char info_fname[],
  char out_fname[], char info_out[] );
























