#include "my_gen_coord.h"
















#define INPUT_FASTA_FNAME "data/ft_hg18/hg18.refSeq.500.100.Mar2006.txt.final.txt"
#define GEN_COORD_BASE "data/ft_hg18/gen_coord/hg18.refSeq.genCoord"



#define SEQ_STEP 500















void do_gen_coord_files( void )
{

  printf( "Printing genome coordinate files...\n" );
  
  do_my_gen_coord_files();

}













void do_my_gen_coord_files( void )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *in = NULL;
  in = (FILE *)open_text_file_reading( INPUT_FASTA_FNAME, "" );
  
  do_gen_coord_files_w_fh( in );
  
  close_file( in );

}













void do_gen_coord_files_w_fh( FILE *in )
{

  int check_non_empty_file( FILE *in );
  
  /*  In gen_coord.c:  */
  int still_going = check_non_empty_file( in ), gene_numb = 0;
  
  while ( still_going )
    /*  In this file, below:  */
    still_going = do_gen_coord_files_single_output_file( &gene_numb, in );

}













int do_gen_coord_files_single_output_file( int *gene_numb, FILE *in )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  char fname[ BUFFER ];
  
  sprintf( fname, "%s.%d.txt", GEN_COORD_BASE, *gene_numb );
  
  FILE *out = NULL;
  out = (FILE *)open_text_file_writing( fname, "" );
  
  int still_going = do_gen_coord_files_w_fhs( gene_numb, in, out );
  
  close_file( out );
  
  return still_going;

}











int do_gen_coord_files_w_fhs( int *gene_numb, FILE *in, FILE *out )
{

  char c;
  
  while (( c = fgetc( in )) != EOF ) {
    if ( c == '>' ) {
      /*  In gen_coord.c:  */
      get_and_put_gencoord_file_entry( in, out );
      if ( ++(*gene_numb) % SEQ_STEP == 0 )
        return 1;
    }
  }
  
  return 0;

}


















