












#include "../ext/struct.h"








typedef struct fh_struct {
  FILE *ft;
  FILE *ind;
} FH;








void do_occur_ft( void );

void do_my_occur_ft( void );

void do_occur_format_w_input( FILE *in );

STR_LIST *get_spec_list_align_fh( STR_LIST *spec_header, FILE *fh );

STR_LIST *get_spec_list_align_single_line( STR_LIST *spec_header, char line[],
  int *numb_of_spec );

STR_LIST *get_new_spec_lister_align_single_line( STR_LIST *spec_header, 
  char line[], int *numb_of_spec );

int spec_in_list( char spec[], STR_LIST *spec_header );

STR_LIST *make_and_put_new_spec_lister_align_line( STR_LIST *spec_header, 
  char spec[], int numb_of_spec );

STR_LIST *make_and_put_existing_new_spec_lister( STR_LIST *spec_header,
  STR_LIST *new, char spec[] );

STR_LIST *put_existing_new_spec_lister_at_end( STR_LIST *spec_header,
  STR_LIST *new );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



void do_occur_format_w_spec_list( STR_LIST *spec_header, FILE *in );

void do_occur_format_w_single_spec_and_step( STR_LIST **spec, FILE *in );

void do_occur_format_w_single_spec( STR_LIST *spec, FILE *in );

void do_occur_format_index_file( char spec[], FILE *in );

void do_occur_format_w_output_index_fh( char spec[], FILE *in, FH *my_fh );

void initialize_count_array( int count[] );

void get_index_motif_count_array( int count[], char spec[], FILE *in );

void get_index_motif_count_array_single_line( int count[], char line[],
  char seq[], char spec[] );

void get_my_index_motif_count_array_single_line( char line[], char seq[],
  char spec[] );

void get_index_motif_count_array_matching_species( char seq[], char curr_seq[] );

void update_count_array_single_seq( int count[], char seq[] );

void get_aligned_seq_no_gaps( char pure_seq[], char seq[] );

void update_count_array_pure_seq( int count[], char pure_seq[] );

void update_count_array_single_bp_pure_seq( int count[], char seq_start[] );

void put_index_motif_count_array_fh( int count[], FH *my_fh );

void put_index_motif_count_entry_single_eightmer( int count[], int i, FH *my_fh );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



void get_occur_format_output_fnames( char fname[], char spec[] );






















