















#include "../ext/struct.h"







typedef struct info_struct {
  int total_genes;
  int cpg_genes;
  int conv_genes;
  int conv_cpg;
  int no_conv_genes;
  int no_conv_cpg;
} INFO;




typedef struct fh_struct {
  FILE *fasta;
  FILE *cpg_fh;
  FILE *conv_fh;
  FILE *no_conv_fh;
  FILE *all_fh;
  FILE *out;
} FH;








void do_cpg_islands( void );

void condense_cpg_island_files( void );

void do_my_cpg_islands( void );

void do_cpg_island_correlation( INFO *my_info, FH *my_fh );

void get_gg_struct_list_fh( GG *gg, FILE *fh );

void do_cpg_island_correlation_single_gene( INFO *my_info, GENCOORD_ENTRY *my_entry,
  char seq[], GG *gg_conv, GG *gg_no_conv, FH *my_fh );

int cpg_in_promoter_region( GENCOORD_ENTRY *my_entry, FILE *fh );

int cpg_in_single_promoter_region( GENCOORD_ENTRY *my_entry, int start, int end );

void print_cpg_island_correlation_output( INFO *my_info, FILE *out );
















