














#include "../ext/struct.h"








#define NUMB_NUCL_BUFFER 2
#define NUMB_ANC_BUFFER 2










void do_converge_lists( void );

void set_conv_list_nucl_array( char nucl_array[ NUMB_NUCL_BUFFER ][ BUFFER ] );

void set_conv_list_anc_array( char anc_array[ NUMB_ANC_BUFFER ][ BUFFER ] );

void do_my_converge_lists( char nucl_array[ NUMB_NUCL_BUFFER ][ BUFFER ], 
  char anc_array[ NUMB_ANC_BUFFER ][ BUFFER ] );

void do_converge_lists_w_fh( char nucl_array[ NUMB_NUCL_BUFFER ][ BUFFER ],
  char anc_array[ NUMB_ANC_BUFFER ][ BUFFER ], FILE *out );

void do_my_converge_lists_w_fh( char nucl_array[ NUMB_NUCL_BUFFER ][ BUFFER ],
  char anc_array[ NUMB_ANC_BUFFER ][ BUFFER ], FILE *hg_total_fh, 
  FILE *hg_no_total_fh, FILE *bird_total_fh, FILE *bird_no_total_fh, FILE *out );

void do_converge_lists_all_anc( char nucl_array[ NUMB_NUCL_BUFFER ][ BUFFER ],
  char anc_array[ NUMB_ANC_BUFFER ][ BUFFER ], FILE *hg_total_fh, 
  FILE *hg_no_total_fh, FILE *bird_total_fh, FILE *bird_no_total_fh, FILE *out );

void do_converge_lists_single_comparison( char major_nucl[], char minor_nucl[],
  char anc_nucl[], FILE *hg_total_fh, FILE *bird_total_fh, FILE *out );

int get_converge_list_intersection_count( int *total_hg, int *total_bird,
  FILE *hg_fh, FILE *bird_fh );

int get_total_lines_file( FILE *fh );

int get_my_converge_list_intersection_count( FILE *hg_fh, FILE *bird_fh );

int get_is_in_list_file( char gene[], FILE *fh );

void do_converge_lists_single_anc( char nucl_array[ NUMB_NUCL_BUFFER ][ BUFFER ],
  char anc_array[ NUMB_ANC_BUFFER ][ BUFFER ], FILE *hg_total_fh, 
  FILE *hg_no_total_fh, FILE *bird_total_fh, FILE *bird_no_total_fh, FILE *out );

void do_converge_lists_single_comparison_single_anc( char major_nucl[],
  char minor_nucl[], char yes_anc[], char no_anc[], FILE *hg_total_fh,
  FILE *hg_no_total_fh, FILE *bird_total_fh, FILE *bird_no_total_fh, FILE *out );

int get_converge_list_intersection_count_single_anc( int *total_hg, int *total_bird, 
  FILE *hg_yes_fh, FILE *bird_yes_fh, FILE *hg_no_fh, FILE *bird_no_fh );

int get_total_lines_file_anc( FILE *yes_fh, FILE *no_fh );

int get_my_converge_list_intersection_count_single_anc( FILE *hg_yes_fh, 
  FILE *bird_yes_fh, FILE *hg_no_fh, FILE *bird_no_fh );

void print_converge_output( int x, float exp, char major_nucl[], char minor_nucl[], 
  char anc_nucl[], FILE *out );




