














#include "../ext/struct.h"













typedef struct fh_struct {
  FILE *ft;
  FILE *ind;
  FILE *label;
  FILE *pos;
  FILE *ind_pos;
} FH;









typedef struct my_fh_struct {
  FILE *ft_fh;
  FILE *ind_fh;
  FILE *align_fh;
  FILE *label_fh;
} MY_FH;








void do_hg18_align_ft( void );

void do_my_hg18_align_ft( void );

void do_hg18_align_ft_w_spec_list( STR_LIST *spec_header );

void do_hg18_align_ft_first_run( STR_LIST *spec_header );

void set_hg18_align_ft_gene_label_binary_file( char spec[], FILE *in );

void do_hg18_align_ft_first_run_w_fh( STR_LIST *spec_header, FILE *in );

void do_hg18_align_ft_first_run_single_spec_and_step( STR_LIST **spec, FILE *in );

void do_hg18_align_ft_first_run_single_spec( STR_LIST *spec, FILE *in );

void do_my_hg18_align_ft_first_run_single_spec( STR_LIST *spec, FILE *in );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void do_hg18_align_ft_count_file( STR_LIST *spec_header );

void do_hg18_align_ft_single_spec_and_step( STR_LIST **spec );

void do_hg18_align_ft_single_spec( STR_LIST *spec );

void do_my_hg18_align_ft_single_spec( char fname_base[], char out_fname[] );

void do_hg18_align_ft_single_spec_w_fh( char fname_base[], FILE *out );

GENE_LIST *get_hg18_align_ft_single_spec( GENE_LIST *gene_header,
  char fname_base[], MOTIF *mf );

void do_hg18_ft_column_count( GENE_LIST *gene_header, char fname_base[], 
  MOTIF *mf, FILE *out );

void do_my_hg18_ft_column_count( GENE_LIST *gene_header, char fname_base[],
  MOTIF *mf, MY_FH *my_fh, FILE *out );

void do_hg18_ft_column_count_w_fhs( GENE_LIST *gene_header, MOTIF *mf, MY_FH *my_fh,
  FILE *out );

void do_hg18_ft_column_count_single_gene( GENE_LIST *gene_header, 
  GENE_LABEL *my_gene, MOTIF *mf, SEQ seq_numb, MY_FH *my_fh, FILE *out );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void do_hg18_align_ft_count_combine( STR_LIST *spec_header );

void do_my_hg18_align_ft_count_combine( STR_LIST *spec_header, 
  FPOS_CELL *fpos_cell );

void do_hg18_align_ft_count_combine_w_fhs( STR_LIST *spec_header,
  FPOS_CELL *fpos_cell, FILE *gene_fh, FILE * out );

void do_my_hg18_align_ft_count_combine_w_fhs( STR_LIST *spec_header,
  FPOS_CELL *fpos_cell, FILE *gene_fh, FILE *out );

int hg18_ft_col_count_combine_still_going( STR_LIST *spec_header, 
  FPOS_CELL *fpos_cell );

void do_hg18_ft_col_count_combine_single_seq( STR_LIST *spec_header, 
  FPOS_CELL *fpos_cell, SEQ seq_numb, FILE *gene_fh, FILE *out );

void do_hg18_ft_col_count_combine_single_spec_and_step( STR_LIST **spec, 
  FPOS_CELL *fpos_cell, SEQ seq_numb, INDEX numb, FILE *gene_fh, FILE *out );

void do_hg18_ft_col_count_combine_single_spec( STR_LIST *spec, FPOS_CELL *fpos_cell,
  SEQ seq_numb, INDEX numb, FILE *gene_fh, FILE *out );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void get_hg18_align_ft_column_single_fname_base( char fname_base[], char spec[] );

void get_hg18_align_ft_column_spec_out_fname( char fname[], char spec[] );

void get_hg18_ft_column_count_single_spec_out_fname( char fname[], char spec[] );






















