#include "func.h"
























void do_function( void )
{

  extern char minor_mode;
  
  switch ( minor_mode ) {
  
  case 'a' :
    /*  In ft.c:  */
    do_hg18_align_ft();
    break;
    
  case 'A' :
    /*  In my_ft.c:  */
    do_total_gene_list_file();
    break;
    
  case 'b' :
    /*  In conv.c:  */
    do_converted_genes();
    break;
    
  case 'B' :
    /*  In conv.c:  */
    copy_converted_genes_hg18();
    break;
    
  case 'c' :
    /*  In mix.c:  */
    mix_files();
    break;  
    
  case 'd' :
    /*  In ft_methyl.c:  */
    do_format_methyl();
    break;
    
  case 'D' :
    /*  In ft_methyl.c:  */
    do_cpg_island_format();
    break;
    
  case 'm' :
    /*  In methyl.c:  */
    do_methylation();
    break;
    
  case 'M' :
    /*  In methyl_seq.c:  */
    do_methyl_seq();
    break;
    
  case 'g' :
    /*  In go_genes.c:  */
    do_go_genes();
    break;
    
  case 'G' :
    /*  In go_genes.c:  */
    do_go_genes_corr();
    break;
    
  case 'h' :
    /*  In sep_go.c:  */
    do_sep_go();
    break;
    
  case 'H' :
    /*  In sep_methyl.c:  */
    do_sep_methyl_seq();
    break;
    
  case 'e' :
    /*  In enrich.c:  */
    do_gene_enrich();
    break;
    
  case 'E' :
    /*  In two_nd_enrich.c:  */
    do_two_node_enrich();
    break;
    
  case 't' :
    /*  In total_enrich.c:  */
    do_total_enrich();
    break;
    
  case 'T' :
    /*  In total_cat.c:  */
    do_total_enrich_cat();
    break;
    
  case 'n' :
    /*  In en_binom.c:  */
    do_enrich_binomial();
    break;
    
  case 'p' :
    /*  In cpg.c:  */
    do_cpg_islands();
    break;
    
  case 'v' :
    /*  In cv.c:  */
    do_converge_lists();
    break;
    
  case 'y' :
    /*  In bird.c:  */
    do_converge_bird_human();
    break;
    
  default :
    error( 11000, "Unknown mode passed to function format.\n" );
    break;
  
  }

}

























