
















#include "../ext/struct.h"











typedef struct my_list_struct {

  SLIST *total;
  
  SLIST *all_and_all;

  SLIST *all_and_c;

  SLIST *a_and_c;
  SLIST *a_and_no_c;
  SLIST *no_a_and_c;
  SLIST *a_no_c_and_c;
  SLIST *a_and_a_no_c;

  SLIST *c_no_a_and_c;
  SLIST *c_and_c;

} MY_LIST;




typedef struct spec_list_struct {
  SLIST *c_and_c;
  SLIST *no_c_and_c;
  SLIST *c_and_no_c;
} SPEC_LIST;










void do_total_enrich_cat( void );

GO_CAT_LIST *get_go_cat_list_from_total_fname( GO_CAT_LIST *go_header,
  char fname[] );

GO_CAT_LIST *get_go_cat_list_from_total_fh( GO_CAT_LIST *go_header, FILE *in );

GO_CAT_LIST *get_my_go_cat_list_from_total_fh( GO_CAT_LIST *go_header, FILE *in );

GO_CAT_LIST *get_go_cat_list_single_go_entry( GO_CAT_LIST *go_header,
  int *still_going, FILE *in );

GO_CAT_LIST *get_go_cat_list_existing_single_go_entry( GO_CAT_LIST *go_header,
  char line[], FILE *in );

GO_CAT_LIST *get_my_go_cat_list_existing_single_go_entry( GO_CAT_LIST *go_header,
  GO_CAT_LIST *go, FILE *in );

GO_CAT_LIST *put_go_cat_lister_into_end_list( GO_CAT_LIST *go_header, 
  GO_CAT_LIST *go );

void set_go_cat_list_total_file_fh( GO_CAT_LIST *go, char line[] );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void do_my_total_enrich_cat( GO_CAT_LIST *go_header, char gene_list_base[],
  char go_gene_fname[], char spec_list_base[], char output_fname[] );

void do_total_enrich_cat_w_fh( GO_CAT_LIST *go_header, char gene_list_base[],
  char go_gene_fname[], char spec_list_base[], FILE *out );

void get_spec_lists( SPEC_LIST *spec_list, char list_base[] );

void do_total_enrich_cat_w_lists( GO_CAT_LIST *go_header, MY_LIST *my_list,
  SPEC_LIST *spec_list, char go_gene_fname[], FILE *out );

void do_total_enrich_cat_single_go_lister_and_step( GO_CAT_LIST **go,
  MY_LIST *my_list, SPEC_LIST *spec_list, char go_gene_fname[], FILE *out );

void do_total_enrich_cat_single_go_lister( GO_CAT_LIST *go, MY_LIST *my_list,
  SPEC_LIST *spec_list, char go_gene_fname[], FILE *out );

void print_total_enrich_go_cat_lister( GO_CAT_LIST *go, FILE *out );

void do_my_total_enrich_cat_single_go_lister( GO_CAT_LIST *go, MY_LIST *my_list, 
  SPEC_LIST *spec_list, char go_gene_fname[], FILE *out );

SLIST *get_go_gene_list_w_go_acc( SLIST *go_gene_header, char acc[], char fname[] );

SLIST *get_go_gene_list_w_go_acc_fh( SLIST *go_gene_header, char acc[], FILE *in );

void do_total_enrich_cat_single_go_lister_gene_list( GO_CAT_LIST *go,
  MY_LIST *my_list, SPEC_LIST *spec_list, SLIST *go_gene_header, FILE *out );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void do_total_enrich_cat_single_go_lister_two_node( GO_CAT_LIST *go,
  MY_LIST *my_list, SPEC_LIST *spec_list, SLIST *go_gene_header, FILE *out );

















