


















#include "../ext/struct.h"









typedef struct ss_struct {

  int bird_total;
  int bird_w_nucl;
  int bird_nucl[ NUMB_OF_NUCL ];
  
  int hg_total;
  int hg_w_nucl;
  int hg_nucl[ NUMB_OF_NUCL ];
  
  int mar_total;
  int mar_w_nucl;
  int mar_nucl[ NUMB_OF_NUCL ];
  
  int hg_bird_w_nucl;
  
  int overlap[ NUMB_OF_NUCL ];
  
  int co_occur[ NUMB_OF_NUCL ][ NUMB_OF_NUCL ][ NUMB_OF_NUCL ];
  
  int total;
  
  int hg_c_mar_a;
  
  FILE *hg_fh;
  FILE *mar_fh;
  FILE *bird_fh;

} SS;








void do_hack_converge( void );

void do_my_hack_converge( void );

void initialize_ss_struct( SS *my_struct );

void do_hack_converge_w_struct( SS *my_struct );

void get_hack_converge_input_fname( char fname[], char spec[] );

void do_hack_converge_w_fhs( SS *my_struct );

void do_hack_converge_single_gene( SS *my_struct, char hg_line[], char bird_line[],
  char mar_line[] );

void do_my_hack_converge_single_gene( SS *my_struct, char hg_entry[], 
  char bird_entry[], char mar_entry[] );

void get_bird_info_single_gene( SS *my_struct, char bird_entry[] );

void get_hg_info_single_gene( SS *my_struct, char hg_entry[] );

void get_mar_info_single_gene( SS *my_struct, char mar_entry[] );

void get_hg_mar_a_to_c_cooccur( SS *my_struct, char hg_entry[], char mar_entry[] );

void get_spec_nucl_overlap( SS *my_struct, char hg_entry[], char bird_entry[], 
  char mar_entry[] );

void get_spec_co_occurs( SS *my_struct, char hg_entry[], char bird_entry[], 
  char mar_entry[] );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void print_hack_converge( SS *my_struct );

void print_hack_converge_bird_info( SS *my_struct );

void print_hack_converge_hg_info( SS *my_struct );

void print_hack_converge_mar_info( SS *my_struct );

void print_co_occur_info( SS *my_struct );

void print_hack_converge_spec_overlap( SS *my_struct );

void print_hack_converge_three_spec_co_occur( SS *my_struct );

void print_hack_converge_three_spec_co_occur_single_mx( SS *my_struct, char i );











