#include "main.h"











#define NUMB 50









int main( int argc, char *argv[] )
{

  printf( "\n" );
  printf( "Executing command...\n\n" );
  
  my_main( argc, argv );
  
  printf( "Program run succeeded.\n\n" );
  
  return 0;

}












void my_main( int argc, char *argv[] )
{

  do_params( argc, argv );
  
  do_program_run();

}













void do_program_run( void )
{

  extern char mode;

  switch ( mode ) {
  
  case 'a' :
    /*  In format/ft.c:  */
    do_phylo_formatting();
    break;
    
  case 'b' :
    /*  In ../format/ft.c:  */
    do_occurrence_formatting();
    break;
    
  case 'c' :
    /*  In ../compare/cp.c:  */
    do_single_spec_comparison();
    break;
    
  case 'C' :
    /*  In ../compare/cp.c:  */
    do_comprehensive_spec_comparisons();
    break;
    
  case 'r' :
    /*  In ../compare/cp.c:  */
    do_forward_reverse_spec_comparison();
    break;

  case 'R' :
    /*  In ../compare/cp.c:  */
    do_forward_rev_comprehensive_spec_comp();
    break;
    
  case 't' :
    /*  In ../tree/tr.c:  */
    do_tree();
    break;
    
  case 'g' :
    /*  In ../gene/gene.c:  */
    do_gene_analysis();
    break;
    
  case 'h' :
    /*  In ../change/ch.c:  */
    do_change();
    break;
    
  case 'v' :
    /*  In ../evol/ev.c:  */
    do_evolution();
    break;
    
  case 'f' :
    /*  In ../func/func.c:  */
    do_function();
    break;
    
  case 'e' :
    /*  In ../en/en.c:  */
    do_enrich();
    break;  
    
  case 'z' :
    /*  In sys.c:  */
//    do_system();
//    break;
    
  case 'Z' :
    /*  In ../hacks/h.c:  */
    do_hacks();
    break;
    
  case '\0' :
    error( 1, "Mode parameter not set.\n" );
    break;
    
  default :
    error( 2, "Unknown mode parameter.\n" );
    break;
  
  }

}











/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/











void print_sep( FILE *fh )
{

  register char i = 0;
  
  while ( i++ < NUMB )
    fprintf( fh, "=" );
    
  fprintf( fh, "\n" );

}











void print_dot_sep( FILE *fh )
{

  register char i = 0;
  
  while ( i++ < NUMB )
    fprintf( fh, "." );
    
  fprintf( fh, "\n" );

}









void error( int numb, char str[] )
{

  fprintf( stderr, "Error number :  %d\n", numb );
  
  fprintf( stderr, "%s\n", str );
  
  fprintf( stderr, "\nProgram aborted.\n\n" );
  
  exit( numb );

}




















