#include "sys.h"























void do_system( void )
{

  extern char minor_mode;
  
  switch ( minor_mode ) {
  
  case 'a' :
    do_system_rev_one();
    break;
    
  case 'b' :
    do_system_rev_two();
    break;
    
  default :
    error( 900, "Unrecognized system call.\n" );
    break;
  
  }
  
}











void do_system_rev_one( void )
{

  do_compare_rev_system_call( "hg19", "canFam2", 1 );
  do_compare_rev_system_call( "hg19", "myoLuc1", 2 );
  do_compare_rev_system_call( "hg19", "pteVam1", 3 );
  do_compare_rev_system_call( "hg19", "eriEur1", 4 );
  do_compare_rev_system_call( "hg19", "sorAra1", 5 );
  do_compare_rev_system_call( "hg19", "loxAfr3", 6 );
  do_compare_rev_system_call( "hg19", "proCap1", 7 );
  do_compare_rev_system_call( "hg19", "echTel1", 8 );
  do_compare_rev_system_call( "hg19", "dasNov2", 9 );
  do_compare_rev_system_call( "hg19", "choHof1", 10 );
  do_compare_rev_system_call( "hg19", "macEug1", 11 );

}













void do_system_rev_two( void )
{

  do_compare_rev_system_call( "hg19", "monDom5", 1 );
  do_compare_rev_system_call( "hg19", "ornAna1", 2 );
  do_compare_rev_system_call( "hg19", "galGal3", 3 );
  do_compare_rev_system_call( "hg19", "taeGut1", 4 );
  do_compare_rev_system_call( "hg19", "anoCar1", 5 );
  do_compare_rev_system_call( "hg19", "xenTro2", 6 );
  do_compare_rev_system_call( "hg19", "tetNig2", 7 );
  do_compare_rev_system_call( "hg19", "fr2", 8 );
  do_compare_rev_system_call( "hg19", "gasAcu1", 9 );
  do_compare_rev_system_call( "hg19", "oryLat2", 10 );
  do_compare_rev_system_call( "hg19", "danRer6", 11 );
  do_compare_rev_system_call( "hg19", "petMar1", 11 );

}











void do_compare_rev_system_call( char spec[], char minor_spec[], int i )
{

  char line[ BUFFER ];
  
  sprintf( line, "./phylo -m R -x %s -X %s -a gggcgg", spec, minor_spec );

  if ( system(NULL) )
    system( line ); 

}



















