













#include "../ext/struct.h"





#define MAJOR_SPEC_NUMB 4
#define MINOR_SPEC_NUMB 2

#define SPEC_BUFFER 10






typedef struct my_elem_struct {
  COUNT co_occur;
  COUNT cons;
  COUNT major_cons;
  COUNT minor_cons;
  STAT frac;
} MY_ELEM;








typedef struct struct_struct {
  MY_ELEM mx[ NUMB_OF_NUCL ][ NUMB_OF_NUCL ];
  COUNT numb_of_orthologs;
  FILE *euth_fh;
  FILE *outgroup_fh;
} STRUCT;














void do_asymmetry_cons( void );

void initialize_my_my_struct( STRUCT *my_struct );

void do_my_asymmetry_cons( STRUCT *my_struct );

void do_asymmetry_cons_w_input_fhs( STRUCT *my_struct );

void do_asymmetry_cons_single_line( STRUCT *my_struct, char major_line[],
  char minor_line[] );

void do_my_asymmetry_cons_single_line( STRUCT *my_struct, char major_line[],
  char minor_line[] );

void do_asymmetry_cons_single_co_occur( STRUCT *my_struct, char major_line[],
  char minor_line[], char major_entry[], char minor_entry[] );

int numb_of_nucls_gene_entry( char entry[] );

void do_asymmetry_cons_single_nucl_co_occur( STRUCT *my_struct, char major_line[],
  char minor_line[], char major_entry[], char minor_entry[], int i, int j );

void do_asymmetry_cons_single_matching_nucl_pair( STRUCT *my_struct,
  char major_line[], char minor_line[], int i, int j );

void do_my_asymmetry_cons_single_matching_nucl_pair( STRUCT *my_struct,
  char major_line[], char minor_line[], int i, int j );

int line_shows_conserved_nucl( char line[], int nucl, int numb_of_spec );

void get_positioned_gene_line( char my_line[], char line[] );

int positioned_line_shows_conserved_nucl( char my_line[], int nucl, 
  int numb_of_spec );

void get_and_put_asymmetry_cons( STRUCT *my_struct );

void set_structure_fracs( STRUCT *my_struct );

void print_asymmetry_cons( STRUCT *my_struct );










