














#include "../ext/struct.h"









#define EUTH_FNAME "data/ft_hg19/gene/eutherian.cons.gene.txt"
#define OUTGROUP_FNAME "data/ft_hg19/gene/outgroup.cons.gene.txt"

#define EUTH_SPEC_NUMB 3
#define OUTGROUP_SPEC_NUMB 2

#define EUTH_MAJOR_SPEC "hg19"
#define OUTGROUP_MAJOR_SPEC "macEug1"






typedef struct el_struct {  
  COUNT both;
  COUNT joint;
} EL;







typedef struct st_struct {
  EL mx[ NUMB_OF_NUCL ][ NUMB_OF_NUCL ];
  FILE *euth_fh;
  FILE *outgroup_fh;
} ST;








void do_cons_bias( void );

void do_my_cons_bias( void );

void initialize_st_bias( ST *my_st );

void do_cons_bias_w_struct( ST *my_st );

void do_cons_bias_w_fh_struct( ST *my_st );

void get_cons_bias( ST *my_st );

void get_cons_bias_positioned_fhs( ST *my_st );

void do_cons_bias_single_line( ST *my_st, char euth_line[], char outgroup_line[] );

void do_my_cons_bias_single_line( ST *my_st, char euth_line[],
  char outgroup_line[] );

void get_major_species_bias_entries( char euth_entry[], char outgroup_entry[],
  char euth_line[], char outgroup_line[] );

int set_major_species_bias_single_entry( char entry[], char line[],
  char spec[], char spec_a[], char spec_b[] );

void do_cons_bias_single_line_major_entries( ST *my_st, char euth_line[],
  char outgroup_line[], char euth_major_entry[], char outgroup_major_entry[] );

int get_minor_string_index( char line[], char major_entry[] );

void do_cons_bias_new_string( ST *my_st, char euth_line[], char outgroup_line[], 
  char euth_entry[], char outgroup_entry[] );

void do_cons_bias_single_nucl_pair( ST *my_st, char euth_line[], 
  char outgroup_line[], char euth_entry[], char outgroup_entry[], char i, char j );

COUNT conserved_nucl_single_branch( char line[], char nucl, int numb_of_spec );

void print_cons_bias_results( ST *my_st );



/*========================================================================*/
/*========================================================================*/
/*========================================================================*/


















