













#include "../ext/struct.h"












void do_gc_box_converge( void );

void do_my_gc_box_converge( void );

void do_gc_box_converge_w_phylo( NODE_LIST *node_header );

void set_conv_struct( CONV *my_conv );

void do_gc_box_converge_w_struct( CONV *my_conv, NODE_LIST *node_header );

void do_my_gc_box_converge_w_struct( CONV *my_conv, NODE_LIST *node_header );

void do_gc_box_converge_set_leaf_list( CONV *my_conv, NODE_LIST *node_header,
  NODE_LIST *leaf_header );

void do_my_gc_converge_set_leaf_list( CONV *my_conv, NODE_LIST *node_header,
  NODE_LIST *leaf_header, FPOS_CELL *fpos_cell );

int do_gc_converge_single_gene( CONV *my_conv, NODE_LIST *node_header,
  NODE_LIST *leaf_header, FPOS_CELL *fpos_cell, SEQ seq_numb );

int do_my_gc_converge_single_gene( CONV *my_conv, NODE_LIST *node_header,
  NODE_LIST *leaf_header, FPOS_CELL *fpos_cell, SEQ seq_numb );

void do_gc_converge_single_gene_set_phylo_tree( CONV *my_conv, 
  NODE_LIST *node_header );

void update_conv_struct_for_gc_converge_single_gene( CONV *my_conv,
  NODE_LIST *node_header );



/*========================================================================*/
/*========================================================================*/
/*========================================================================*/



void update_conv_data_struct_major_conv( CONV_DATA *x, NODE_LIST *node_header );

void update_conv_data_struct_major_conv_w_nodes( CONV_DATA *x, NODE_LIST *neo,
  NODE_LIST *pri, NODE_LIST *mam, NODE_LIST *the, NODE_LIST *amn, NODE_LIST *gal,
  NODE_LIST *tae, NODE_LIST *ano );

void update_conv_data_struct_comp_conv( CONV_DATA *conv, NODE_LIST *node_header );

void update_conv_data_struct_comp_conv_w_nodes( CONV_DATA *x, NODE_LIST *mam,
  NODE_LIST *gal, NODE_LIST *tae, NODE_LIST *hum, NODE_LIST *mou,
  NODE_LIST *cow );

void update_conv_data_struct_spec_conv( CONV_DATA *conv, NODE_LIST *node_header );

void update_conv_data_struct_spec_conv_w_nodes( CONV_DATA *conv, NODE_LIST *gal,
  NODE_LIST *tae, NODE_LIST *hum, NODE_LIST *mou, NODE_LIST *mon, NODE_LIST *mac,
  NODE_LIST *xen, NODE_LIST *ano, NODE_LIST *orn, NODE_LIST *cow, NODE_LIST *amn,
  NODE_LIST *mam );

int get_ancestral_vert_count( NODE_LIST *mon, NODE_LIST *mac, NODE_LIST *xen,
  NODE_LIST *ano, NODE_LIST *orn, NODE_LIST *amn, NODE_LIST *mam, char nucl );

int present_only( NODE_LIST *x, char nucl );

int present( NODE_LIST *x, char nucl );

void update_conv_data_struct_w_ancestral_count( CONV_DATA *conv, NODE_LIST *gal, 
  NODE_LIST *tae, NODE_LIST *hum, NODE_LIST *mou, NODE_LIST *cow,
  int ancestral_count, char nucl );



/*========================================================================*/
/*========================================================================*/
/*========================================================================*/



void print_gc_box_converge( CONV *my_conv );

void print_gc_box_converge_spec_data( CONV_DATA *conv );

void set_gc_box_converge_spec_data_notes( CONV_DATA *conv );

void set_gc_box_non_func_converge_spec_data( CONV_DATA *conv );

void print_gc_box_converge_spec_data_fh( CONV_DATA *conv, FILE *fh );

void get_expected_gc_box_converge_mx( STAT exp[ DBUFF ][ DBUFF ][ DBUFF ],
  COUNT mx[ DBUFF ][ DBUFF ][ DBUFF ], PVAL pval[ DBUFF ][ DBUFF ][ DBUFF ] );

void print_gc_box_converge_single_mx_fh( CONV_DATA *conv, 
  COUNT mx[ DBUFF ][ DBUFF ][ DBUFF ], STAT exp[ DBUFF ][ DBUFF ][ DBUFF ],
  PVAL pval[ DBUFF ][ DBUFF ][ DBUFF ], char major_spec[], char minor_spec[], 
  FILE *fh );

STAT get_conservation_mx( COUNT mx[ DBUFF ][ DBUFF ] );

void print_gc_box_converge_conv_data( CONV_DATA *conv );

void print_gc_box_converge_comp_data( CONV_DATA *conv );














