















#include "../ext/struct.h"









void make_node_tree( void );

NODE_LIST *get_node_tree_w_fname( NODE_LIST *node_header, char fname[] );

NODE_LIST *get_node_tree_w_fh( NODE_LIST *node_header, FILE *fh );

NODE_LIST *get_leaf_node_list( NODE_LIST *leaf_header, FILE *fh );

NODE_LIST *get_and_put_single_leaf_node_lister( NODE_LIST *leaf_header,
  char line[] );

NODE_LIST *get_single_leaf_node_lister_from_line( NODE_LIST *node, char line[] );

NODE_LIST *put_single_leaf_node_lister_into_leaf_list( NODE_LIST *leaf_header, 
  NODE_LIST *node );

NODE_LIST *get_node_tree_w_species_leaf_list( NODE_LIST *node_header, 
  NODE_LIST *leaf_header, FILE *fh );

void get_node_tree_single_line( NODE_LIST *leaf_header, char line[], FILE *fh );

int absent_line( char line[] );

void get_node_tree_multi_branch_entry( NODE_LIST *leaf_header, char line[],
  FILE *fh );

void get_my_node_tree_multi_branch_entry( NODE_LIST *leaf_header, char label[],
  int numb, FILE *fh );

void set_node_tree_multi_branch_entry( NODE_LIST *leaf_header, NODE_LIST *node,
  int numb, FILE *fh );

void get_node_tree_multi_branch_entry_single_line( NODE_LIST *leaf_header,
  NODE_LIST *node, int index, FILE *fh );

void get_my_node_tree_single_line( NODE_LIST *leaf_header, char line[] );

void remove_brackets( char x[] );

void build_single_node_from_downstream_nodes( NODE_LIST *a, NODE_LIST *b, 
  TIME length_a, TIME length_b, char ancestor[] );

void put_single_node_to_downstream_nodes( NODE_LIST *a, NODE_LIST *b,
  NODE_LIST *x );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



NODE_LIST *find_node_lister_label_w_leaf_list( NODE_LIST *leaf_header, 
  char label[] );

NODE_LIST *find_node_lister_label_match_upstream( NODE_LIST *node, char label[] );

NODE_LIST *get_node_tree_header( NODE_LIST *node );

NODE_LIST *get_leaf_node_header( NODE_LIST *root );

TIME get_node_tree_time( NODE_LIST *node );

int get_node_time_array( TIME x[], NODE_LIST *node );

TIME current_node_tree_time( NODE_LIST *node, char i );

void check_node_time_array( TIME x[], int numb_down_nodes );

void print_node_tree( NODE_LIST *node );

void print_node_tree_fh( NODE_LIST *node, FILE *fh );

void print_my_node_tree_fh( NODE_LIST *node, FILE *fh );

void print_node_tree_existing_node_fh( NODE_LIST *node, FILE *fh );

void print_curr_ancestor_node_fh( NODE_LIST *node, FILE *fh );

void print_node_tree_leaves_ancestor_node( NODE_LIST *node, FILE *fh );

void do_print_node_recursion( NODE_LIST *node, FILE *fh );

void set_split_node( NODE_LIST *node, char split_label[] );

void do_split_mode_recursion( NODE_LIST *node, char split_label[] );

INDEX get_numb_of_leaves_leaf_header( NODE_LIST *leaf_header );

NODE_LIST *get_node_from_label( NODE_LIST *node, char label[] );














