#include "tr.h"




























void do_tree( void )
{

  extern char minor_mode;
  
  switch ( minor_mode ) {
  
  case 'c' :
    /*  In cons.c:  */
    do_cons_patterns();
    break;
    
  case 'n' :
    /*  In cons.c:  */
    count_conserved_nucls();
    break;
    
  case 'a' :
    /*  In asy.c:  */
    do_asymmetry_cons();
    break;
    
  case 'b' :
    /*  In co_occur.c:  */
    do_cons_bias();
    break;
    
  case 'f' :
    /*  Makes 'column.txt' files, text formatting files...  */
    /*  In text_ft.c:  */
    do_individual_spec_text_ft();
    break;
    
  case 't' :
    /*  In node.c:  */
    make_node_tree();
    break;
    
  case 'p' :
    /*  In ancestor.c:  */
    do_ancestral_nucls();
    break;
    
  case 'v' :
    /*  In conv.c:  */
    do_gc_box_converge();
    break;
    
  case 'V' :
    /*  In my_conv.c:  */
    do_gc_box_converge_sep();
    break;
    
  case 'z' :
    /*  In check.c:  */
    check_tree_occurs();
    break;  
    
  case '\0' :
    error( 4000, "Minor mode not set for tree command.\n" );
    
  default :
    error( 4001, "Unknown minor mode passed to tree function.\n" );
    break;
  
  }

}
















