


















#include "../ext/struct.h"









COUNT_CELL *create_count_cell( COUNT_CELL *x, int nn );

STAT_CELL *create_stat_cell( STAT_CELL *x, int nn );

STAT_CELL *create_stat_cell_matrix( STAT_CELL *x, int ii, int jj );

GENE_CELL *create_gene_cell( GENE_CELL *x, int nn );

GENERATION *create_generation( GENERATION *gg, int nn );

GG *create_gg( GG *x, int ii, int jj, int hh );

PART_CELL *create_part_cell( PART_CELL *x, int nn );

PART_GEN *create_part_gen( PART_GEN *x );

INFO *create_info( INFO *x );

MUT_RATE_CELL *create_mut_rate_cell( MUT_RATE_CELL *x, int nn );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



COUNT_CELL *initialize_count_cell( COUNT_CELL *x, COUNT *xx, int nn );

STAT_CELL *initialize_stat_cell( STAT_CELL *x, STAT *xx, int nn );

STAT_CELL *initialize_stat_cell_matrix( STAT_CELL *x, STAT *xx, int i, int j );

GENE_CELL *initialize_gene_cell( GENE_CELL *x, GENE *xx, int nn );

void initialize_gene( GENE *g );

GENERATION *initialize_generation( GENERATION *gg, GENE_CELL *a, GENE_CELL *c );

GG *initialize_gg( GG *x, STAT_CELL *y, STAT_CELL *w );

PART_CELL *initialize_part_cell( PART_CELL *x, PART *xx, int nn );

void initialize_part_array( PART *x, int nn );

void initialize_part( PART *b );

PART_GEN *initialize_part_gen( PART_GEN *x, PART_CELL *b, STAT_CELL *w );

INFO *initialize_info( INFO *x, STAT_CELL *y, STAT_CELL *w, PART *B );

MUT_RATE_CELL *initialize_mut_rate_cell( MUT_RATE_CELL *x, MUT_RATE *xx, int nn );

void initialize_mut_rate_array( MUT_RATE *array, int nn );

void initialize_mut_rate_elem( MUT_RATE *mm );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



void kill_count_cell( COUNT_CELL *x );

void kill_stat_cell( STAT_CELL *x );

void kill_gene_cell( GENE_CELL *x );

void kill_generation( GENERATION *gg );

void kill_gg( GG *gg );

void kill_part_cell( PART_CELL *x );

void kill_info( INFO *x );

void kill_mut_rate_cell( MUT_RATE_CELL *x );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



void check_null( int numb, ... );

void check_single_null( void *x );























