#include "param.h"






























void set_params( int argc, char *argv[] )
{

  set_default_params();
  
  set_my_params( argc, argv );

}












void set_default_params( void )
{

  extern char mode, minor_mode;
  extern int numb_param;
  
  mode = '\0';
  minor_mode = '\0';
  
  numb_param = 0;

}










void set_my_params( int argc, char *argv[] )
{

  int i;
  
  for ( i = 1; i < argc; i += 2 )
    set_single_param( argv[ i ], argv[ i + 1 ] );

}












void set_single_param( char *type, char *param )
{

  if ( ! strcmp( type, "-m" ))
    set_mode( param );
    
  if ( ! strcmp( type, "-M" ))
    set_minor_mode( param );
    
  if ( ! strcmp( type, "-i" ))
    set_numb_param( param );

}











void set_mode( char *param )
{

  extern char mode;
  
  mode = *param;

}











void set_minor_mode( char *param )
{

  extern char minor_mode;
  
  minor_mode = *param;

}












void set_numb_param( char *param )
{

  extern int numb_param;
  
  numb_param = atoi( param );

}












