#include "stream.h"






















FILE *open_text_file_reading( char a[], char b[] )
{

  FILE *fh = NULL;
  
  char fname[ BUFFER ];
  get_fname_from_base_ext( fname, a, b );
  
  fh = (FILE *)fopen( fname, "r" );
  
  if ( fh == NULL ) {
    char err[ BUFFER ];
    sprintf( err, "Unable to open file '%s'\n", fname );
    error( 100, err );
  }
  
  return fh;

}












FILE *open_text_file_writing( char a[], char b[] )
{

  FILE *fh = NULL;
  
  char fname[ BUFFER ];
  get_fname_from_base_ext( fname, a, b );
  
  fh = (FILE *)fopen( fname, "w" );
  
  if ( fh == NULL ) {
    char err[ BUFFER ];
    sprintf( err, "Unable to open file '%s'\n", fname );
    error( 100, err );
  }
  
  return fh;

}














void get_fname_from_base_ext( char fname[], char a[], char b[] )
{

  if ( b[ 0 ] == '\0' ) {
    strcpy( fname, a );
    return;
  }
  
  sprintf( fname, "%s.%s", a, b );

}













void close_file( FILE *fh )
{

  if ( fclose( fh ) != 0 )
    error( 120, "Error in closing file.\n" );

}











void set_position( long x, FILE *fh )
{
  if ( fseek( fh, x, SEEK_SET ) != 0 )
    error( 121, "Unable to set filehandle position.\n" );
}






