


















#include "../ext/struct.h"









void do_diploid_model( void );

void set_diploid_params( void );

void set_initial_diploid_generation( GENERATION *gg );

void set_initial_box_cell( GENE_CELL *cell, STAT freq );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void do_my_diploid_model( GENERATION *gg );

void do_diploid_model_fh( GENERATION *gg, FILE *fh );

void do_diploid_model_single_generation( GENERATION *gg, int t, FILE *fh );

void update_diploid_model_single_generation( GENERATION *gg );

void update_my_diploid_model_single_generation( GENERATION *gg );

void update_diploid_model_two_gen_structs( GENERATION *new_gg, GENERATION *gg );

void update_diploid_model_tf_freqs( GENERATION *new_gg, GENERATION *gg );

STAT get_diploid_f_aa( GENERATION *gg );

STAT get_diploid_f_cc( GENERATION *gg );

STAT get_diploid_f_ac( GENERATION *gg );

void update_diploid_model_box_freqs( GENERATION *new_gg, GENERATION *gg );

void update_diploid_model_single_box_gene( GENE *new_a, GENE *new_c, GENE *a,
  GENE *c, STAT p, STAT q );

void set_b_freq_gene_elem( GENE *x );

void set_y_freq_gene_elem( GENE *x );

void copy_generations( GENERATION *a, GENERATION *b );

void copy_gene_cell( GENE_CELL *a, GENE_CELL *b );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void do_diploid_model_mutations( GENERATION *gg );

void do_diploid_model_mutation_single_gene( GENE *a, GENE *c );

void update_totals_gene_cell( GENE_CELL *cell );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void print_model_header( FILE *fh );

void print_model_header_comments( FILE *fh );

void print_model_generation( GENERATION *gg, int t, FILE *fh );




























