

















#include "../ext/struct.h"





void do_partition_model_mutations( INFO *my_info, INFO *curr_info,
  PARAMS *my_params );

void do_partition_model_mutations_w_matrices( INFO *my_info, INFO *curr_info,
  STAT_CELL *t, STAT_CELL *a, STAT_CELL *b, PARAMS *my_params );

void set_mutation_matrix( STAT_CELL *t, PARAMS *my_params );

void do_partition_model_mutations_mx( INFO *my_info, INFO *curr_info, 
  STAT_CELL *t, STAT_CELL *a, STAT_CELL *b, PARAMS *my_params );

void do_mutation_single_partition( PART *part, STAT_CELL *t, STAT_CELL *a,
  STAT_CELL *b );

void set_freq_vector_partition( STAT_CELL *a, PART *part );

void set_haplotype_freqs_partition( PART *part, STAT_CELL *b );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void do_one_partition_model_mutations( INFO *my_info, INFO *curr_info,
  PARAMS *my_params );

void do_one_partition_model_mutations_w_matrices( INFO *my_info, INFO *curr_info,
  STAT_CELL *t, STAT_CELL *a, STAT_CELL *b, PARAMS *my_params );

void do_one_partition_model_mutations_mx( INFO *my_info, INFO *curr_info,
  STAT_CELL *t, STAT_CELL *a, STAT_CELL *b, PARAMS *my_params );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void do_partition_model_mutations_no_ac( INFO *my_info, INFO *curr_info,
  PARAMS *my_params );

void do_partition_model_mutations_no_ac_w_matrices( INFO *my_info, 
  INFO *curr_info, STAT_CELL *t, STAT_CELL *a, STAT_CELL *b, PARAMS *my_params );

void set_mutation_matrix_no_ac( STAT_CELL *t, PARAMS *my_params );




















